commit eaa36660de7e174498618d69d7277d44a2f24c3d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 19 13:58:24 2011 +0000

    tg3: Update version to 3.120
    
    This patch updates the tg3 version to 3.120.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 941ec90f35603f35466988efd01395377fd00475
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 19 13:58:23 2011 +0000

    tg3: Add external loopback support to selftest
    
    This patch adds external loopback support to tg3's ethtool selftest.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 28a4595786a64fb51d41c0bad819256198525e49
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 19 13:58:22 2011 +0000

    tg3: Restructure tg3_test_loopback
    
    The tg3_test_loopback() function is starting to get more complicated as
    more loopback tests are added.  This patch cleans up the code.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5e5a7f371ffea4b5aeca60253f912e0b36391495
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 19 13:58:21 2011 +0000

    tg3: Pull phy int lpbk setup into separate func
    
    This patch pulls out the internal phy loopback setup code into a
    separate function.  This cleans up the loopback test code and makes it
    available for NETIF_F_LOOPBACK support later.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6e01b20b21d6b2131f27a7c068ff71a7fbe58796
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 19 13:58:20 2011 +0000

    tg3: Consilidate MAC loopback code
    
    The driver puts the device into MAC loopback in two places in the
    driver.  This patch consolidates the code into a single routine.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2215e24ceb74b701c34b2ebe7cdc96e5509ac565
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 19 13:58:19 2011 +0000

    tg3: Remove dead code
    
    Now that CPMU devices don't do MAC loopback, all the CPMU power saving
    mode adjustments are unneeded.  This patch removes the dead code.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit afc4b13df143122f99a0eb10bfefb216c2806de0
Author: Jiri Pirko <jpirko@redhat.com>
Date:   Tue Aug 16 06:29:01 2011 +0000

    net: remove use of ndo_set_multicast_list in drivers
    
    replace it by ndo_set_rx_mode
    
    Signed-off-by: Jiri Pirko <jpirko@redhat.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit adfc5217e9db68d3f0cec8dd847c1a6d3ab549ee
Author: Jeff Kirsher <jeffrey.t.kirsher@intel.com>
Date:   Thu Apr 7 06:03:04 2011 -0700

    broadcom: Move the Broadcom drivers
    
    Moves the drivers for Broadcom devices into
    drivers/net/ethernet/broadcom/ and the necessary Kconfig and Makefile
    changes.
    
    CC: Eilon Greenstein <eilong@broadcom.com>
    CC: Michael Chan <mchan@broadcom.com>
    CC: Matt Carlson <mcarlson@broadcom.com>
    CC: Gary Zambrano <zambrano@broadcom.com>
    CC: "Maciej W. Rozycki" <macro@linux-mips.org>
    Signed-off-by: Jeff Kirsher <jeffrey.t.kirsher@intel.com>

commit a051294423b015c5c89f2ed78f7fe0893b775098
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:54 2011 +0000

    tg3: Remove 5719 jumbo frames and TSO blocks
    
    The A0 revision of this chip is the only device that requires these
    features to be disabled.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e31aa9870627106aebddd280aab8ecb2f493246a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:53 2011 +0000

    tg3: Break larger frags into 4k chunks for 5719
    
    The 5719 has bug where RDMAs larger than 4k can cause problems.  This
    patch works around the problem by dividing larger DMA requests into
    something the hardware can handle.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 84b67b27e9531e9a70c9e8cd952d66c55f4d0ddb
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:52 2011 +0000

    tg3: Add tx BD budgeting code
    
    As the driver breaks large skb fragments into smaller submissions to the
    hardware, there is a new danger that BDs might get exhausted before all
    fragments have been mapped.  This patch adds code to make sure tx BDs
    aren't oversubscribed and flag the condition if it happens.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d1a3b7377d3b6a01ec5f70adb32173b13233aabf
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:51 2011 +0000

    tg3: Consolidate code that calls tg3_tx_set_bd()
    
    This patch consolidates all code that populates tx BDs into a single
    routine.  Setting tx BDs needs to be more carefully controlled to see if
    workarounds need to be applied.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e01ee14d499e5d09c0a9db0cac2545a018849e3d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:50 2011 +0000

    tg3: Add partial fragment unmapping code
    
    The following patches are going to break skb fragments into smaller
    sizes.  This patch attempts to make the change easier to digest by only
    addressing the skb teardown portion.
    
    The patch modifies the driver to skip over any BDs that have a flag set
    that indicates the BD isn't the beginning of an skb fragment.  Such BDs
    were a result of segmentation and do not need a pci_unmap_page() call.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0d681b27b0efc962a3038a316e78373de7bfe1ce
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:49 2011 +0000

    tg3: Generalize tg3_skb_error_unmap()
    
    In the following patches, unmapping skb fragments will get just as
    complicated as mapping them.  This patch generalizes
    tg3_skb_error_unmap() and makes it the one-stop-shop for skb unmapping.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 13350ea78bd687a229af0f6052d2f45aa50a6524
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:48 2011 +0000

    tg3: Remove short DMA check for 1st fragment
    
    The first fragment of an skb should always be greater than 8 bytes.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 92cd3a17ce9c719abb4c28dee3438e0c641f8de4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:47 2011 +0000

    tg3: Simplify tx bd assignments
    
    In the following patches, the process the driver will use to assign skb
    fragments to transmit BDs will get more complicated.  To prepare for
    that new code, this patch seeks to simplify how transmit BDs are
    populated.  It does this by separating the code that assigns the BD
    members from the logic that controls how the fields are set.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit df8944cf5cd3794c46e95e0404038376ee7f8dda
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 27 14:20:46 2011 +0000

    tg3: Reintroduce tg3_tx_ring_info
    
    The following patches will require the use of an additional flag in the
    ring_info structure.  The use of this flag is tx path specific, so this
    patch defines a specialized ring_info structure.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bda18faf630ae3731f4b4e8f4b94a26e326c4797
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 20 10:20:57 2011 +0000

    tg3: Fix NVRAM selftest failures for 5720 devs
    
    This patch fixes NVRAM selftest failures for 5720 devices by fixing the
    checksum area size.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 535a490eaddab484c53717fe2feeba800c9cdda2
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 20 10:20:56 2011 +0000

    tg3: Return size from tg3_vpd_readblock()
    
    Newer VPD datablocks can exceed the size the tg3 driver is traditionally
    used to.  This can cause some of the routines that operate on the VPD
    data to fail when in-fact they could have succeeded had they known the
    correct size.  This patch fixes the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3aa1cdf87c0b3f2345e75c474acc32ebbf0a4724
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 20 10:20:55 2011 +0000

    tg3: Fix int selftest for recent devices.
    
    This patch fixes interrupt selftest failures for recent devices (57765,
    5717, 5718. 5719, 5720) by disabling MSI one-shot mode and applying the
    status tag workaround to the selftest code.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9d53fa129628d4899083b06fa66b7ca10fed8eb4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 20 10:20:54 2011 +0000

    tg3: Fix RSS indirection table distribution
    
    The current RSS indirection table is populated such that more traffic
    will hit the first RSS ring.  This patch adjusts the indirection table
    so that the load is more evenly distributed.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5baa5e9aa28baccd2a1227095c25bb3e999f250d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 20 10:20:53 2011 +0000

    tg3: Add 5719 and 5720 to EEE_CAP list
    
    This patch adds the 5719 and the 5720 to the list of devices that are
    EEE capable.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b715ce947f51c6637e78b262501f0c4ff9d848cc
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 20 10:20:52 2011 +0000

    tg3: Fix link down notify failure when EEE disabled
    
    Occasionally, when the network cable is removed after a successful
    autonegotiation, the device will not send a link down interrupt to the
    driver.  This happens because of a bad interaction of an EEE
    workaround.  The fix is to adjust the code so that the root cause
    condition does not happen.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit be671947b5b3efc6863ff429c1f265aa38e291db
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 20 10:20:51 2011 +0000

    tg3: Fix link flap at 100Mbps with EEE enabled
    
    This patch increases the scope of the EEE interoperability workaround
    to include more asic revisions.  The workarond value is tuned to
    workaround a link flap issue at 100Mbps.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9e975cc291d80d5e4562d6bed15ec171e896d69b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 20 10:20:50 2011 +0000

    tg3: Fix io failures after chip reset
    
    Commit f2096f94b514d88593355995d5dd276961e88af1, entitled
    "tg3: Add 5720 H2BMC support", needed to add code to preserve some bits
    set by firmware.  Unfortunately the new code causes throughput to stop
    after a chip reset because it enables state machines before they are
    ready.  This patch undoes the problematic code.  The bits will be
    restored later in the init sequence.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cd0d7228b4f0279f219bc555fa0192dc072d79cd
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 13 09:27:33 2011 +0000

    tg3: Match power source to driver state
    
    Now that the driver state (and power source) is being more intensely
    scrutinized, we need to make sure it is correct 100% of the time.  This
    patch finds and fixes all dangling power state transitions.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3a1e19d383c7b91c8af52e8938ab60c40e3d26b3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 13 09:27:32 2011 +0000

    tg3: Add function status reporting
    
    This patch adds code to update the status of the function to a common
    location to the critical section added in the previous patch.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6f5c8f8317d37045ffc7ea21dab8319a53c1ae57
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 13 09:27:31 2011 +0000

    tg3: Create critical section around GPIO toggling
    
    The code that performs the power source switching will need to consider
    the status of the other devices before making any switches.  The status
    updates and power source switching will need to be an atomic operation,
    so a critical section will be needed.  This patch establishes the
    critical section through a CPMU mutex.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 69f11c9936ba310ed3620072983da6ed95e86cc0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 13 09:27:30 2011 +0000

    tg3: Determine PCI function number in one place
    
    tg3 devices will need to know exactly what function number they are so
    that they can communicate their status to the other functions.  In a KVM
    environment, the function number of a device presented by the kernel
    might not be the true function number, so an alternative method to
    determine the function number is needed.
    
    This patch used to contain an implementation for the alternative method,
    but recently we discovered a hardware bug that renders it incorrect.
    While new method is not yet known, it is still useful to consolidate the
    code that determines the PCI function to one location and use the
    results throughout the code.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bed9829f3ec4b30d5cbec6511a11368ba5f169fb
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 13 09:27:29 2011 +0000

    tg3: Check transitions to D0 power state
    
    Currently pci_set_power_state() does not return useful return codes for
    transitions to the D0 power state.  If a device refuses to go into D0,
    the PCI layer issues a warning but returns success.
    
    Entering into D0 is a requirement for correct operation of tg3 devices
    though.  If the PCI layer should be changed to return an error code for
    this type of failure, the tg3 driver would be interested in catching it
    and reacting to it.  This patch makes the necessary modifications.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 168212858712b12c65e0fa1bec6c9c65808e7621
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 13 09:27:28 2011 +0000

    tg3: Move power state transitions to init_one
    
    The tg3 driver is going to require memory mapped register access much
    sooner than before.  This patch makes sure the device is in the D0 power
    state as soon as possible, and moves the code that enables the memory
    arbiter outside tg3_get_eeprom_hw_cfg() where it can be more easily
    monitored.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c9cab24e954867a03ab833ea3b4c0e6e607eb0d6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jul 13 09:27:27 2011 +0000

    tg3: Detect APE enabled devs earlier
    
    The following patch will require the driver to communicate with the APE
    much sooner than before.  This patch make sure the APE registers are
    memory mapped and that the ENABLE_APE bit is set before the first use.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 708ebb3a51489e70bc2b67b2772deea336eba849
Author: Jon Mason <jdmason@kudzu.us>
Date:   Mon Jun 27 12:56:50 2011 +0000

    tg3: remove unnecessary read of PCI_CAP_ID_EXP
    
    The PCIE capability offset is saved during PCI bus walking.  Use the
    value from pci_dev instead of checking in the driver and saving it off
    the the driver specific structure.  It will remove an unnecessary search
    in the PCI configuration space if this value is referenced instead of
    reacquiring it.
    
    v2 of the patch re-adds the PCI_EXPRESS flag and adds comments
    describing why it is necessary.
    
    [ pdev->pcie_cap --> pci_pcie_cap(pdev) -DaveM ]
    
    Signed-off-by: Jon Mason <jdmason@kudzu.us>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d515b450bfd50d355c5b3230685b997faeee5c49
Author: Richard Cochran <richardcochran@gmail.com>
Date:   Sun Jun 19 03:31:41 2011 +0000

    tg3: fix race in transmit time stamping.
    
    Signed-off-by: Richard Cochran <richard.cochran@omicron.at>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 520b2756d9414cb6b0f6fc70714e95ee9248ebf4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 13 13:39:02 2011 +0000

    tg3: Create funcs for power source switching
    
    The power source switching code is about to get a little more complex.
    This patch seeks to simplify future power source switching patches by
    clarifying the existing code.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@conan.davemloft.net>

commit 221c56373ee7088dd3015b928782d5e70dc5074e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 13 13:39:01 2011 +0000

    tg3: Migrate phy preprocessor defs to system defs
    
    This patch changes to code to use some of the preprocessor
    definitions from mii.h over its homegrown equivalents.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@conan.davemloft.net>

commit 5bb09778e2196770d218e82904f15b558d9a1e50
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 13 13:39:00 2011 +0000

    tg3: Show flowctrl settings through get_settings()
    
    This patch adds code to present the flow control advertisements through
    the ethtool get_settings callback.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@conan.davemloft.net>

commit 727a6d9f39604b5592e474295960fceeb523ae4f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 13 13:38:58 2011 +0000

    tg3: Add more selfboot formats to NVRAM selftest
    
    This patch adds more selfboot formats to the NVRAM selftest.  It also
    changes the code to return an error on an unsupported NVRAM format.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@conan.davemloft.net>

commit eb69d564a3f34df602bd9b0fae94e14fad23de2d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 13 13:38:57 2011 +0000

    tg3: Remove 4G_DMA_BNDRY_BUG flag
    
    Now that all chips have this bug, the flag checks become useless code.
    This patch removes the flag.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@conan.davemloft.net>

commit daf9a55387df8f429d1219bbdabba1ab33d2a479
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 13 13:38:56 2011 +0000

    tg3: Remove 40BIT_DMA_LIMIT_BUG
    
    This patch removes the 40BIT_DMA_LIMIT_BUG flag.  There already exists a
    flag for this purpose (TG3_FLAG_40BIT_DMA_BUG) and was already being
    used in the correct spot.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@conan.davemloft.net>

commit 0e6cf6a9e3cf911577b1dde0dc724f634e4ca119
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 13 13:38:55 2011 +0000

    tg3: Workaround tagged status update bug
    
    On rare occasions, writing the tag to the interrupt mailbox does not
    reenable interrupts.  This patch fixes the problem by reissuing the
    mailbox update.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@conan.davemloft.net>

commit 2669069aacc914821b45fe14a49e7fe0ba5d10bd
Author: Richard Cochran <richardcochran@gmail.com>
Date:   Sun Jun 12 02:19:02 2011 +0000

    tg3: enable transmit time stamping.
    
    This patch enables software (and phy device) transmit time stamping
    for the TIGON3 driver. Compile tested only.
    
    Cc: Matt Carlson <mcarlson@broadcom.com>
    Cc: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Richard Cochran <richard.cochran@omicron.at>
    Signed-off-by: David S. Miller <davem@conan.davemloft.net>

commit a6b7a407865aab9f849dd99a71072b7cd1175116
Author: Alexey Dobriyan <adobriyan@gmail.com>
Date:   Mon Jun 6 10:43:46 2011 +0000

    net: remove interrupt.h inclusion from netdevice.h
    
    * remove interrupt.g inclusion from netdevice.h -- not needed
    * fixup fallout, add interrupt.h and hardirq.h back where needed.
    
    Signed-off-by: Alexey Dobriyan <adobriyan@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9a2e0fb0893ddf595d0a372e681f5b98017c6d90
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Jun 2 13:01:39 2011 +0000

    tg3: Fix tg3_skb_error_unmap()
    
    This function attempts to free one fragment beyond the number of
    fragments that were actually mapped.  This patch brings back the limit
    to the correct spot.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Tested-by: Alex Williamson <alex.williamson@redhat.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 1dcb14d9e874d12bab9ceeba776b742f1682b0a6
Author: Meelis Roos <mroos@ut.ee>
Date:   Wed May 25 05:43:47 2011 +0000

    Add Fujitsu 1000base-SX PCI ID to tg3
    
    This patch adds the PCI ID of Fujitsu 1000base-SX NIC to tg3 driver.
    Tested to detect the card, MAC and serdes, not tested with link at the
    moment since I have no fiber switch here. I did not add new constants to
    the pci_ids.h header file since these constants are used only here.
    
    Signed-off-by: Meelis Roos <mroos@linux.ee>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7196cd6c3d4863000ef88b09f34d6dd75610ec3e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 16:02:44 2011 +0000

    tg3: Add braces around 5906 workaround.
    
    Commit dabc5c670d3f86d15ee4f42ab38ec5bd2682487d, entitled
    "tg3: Move TSO_CAPABLE assignment", moved some TSO flagging code around.
    In the process it failed to add braces around an exceptional 5906
    condition.  This patch fixes the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d542fe27c86ecf932f40c898881208ccdaef9dc5
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 16:02:43 2011 +0000

    tg3: Fix NETIF_F_LOOPBACK error
    
    Mahesh Bandewar noticed that the features cleanup in commit
    0da0606f493c5cdab74bdcc96b12f4305ad94085, entitled
    "tg3: Consolidate all netdev feature assignments", mistakenly sets
    NETIF_F_LOOPBACK by default.  This patch corrects the error.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Mahesh Bandewar <maheshb@google.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 43a5f002afc6f24891e57d31275f34e19a1a07d0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:56 2011 +0000

    tg3: Update version to 3.119
    
    This patch updates the tg3 version to 3.119.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 310050fad8962a2ebc70011353a549614e118152
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:55 2011 +0000

    tg3: Apply rx_discards fix to 5719/5720
    
    Commit 4d95847381228639844c7197deb8b2211274ef22, entitled
    "tg3: Workaround rx_discards stat bug", was intended to be applied to
    the 5717, 5718, 5719_A0, and 5720 A0 chip revisions.  The implementation
    missed the latter two when applying the fix in a critical area.  This
    patch fixes the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6ff6f81dd4ec08945e10147dbfe611569ef4cc09
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:54 2011 +0000

    tg3: Remove excessive parenthesis
    
    This patch removes some excessive parenthesizing.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0da0606f493c5cdab74bdcc96b12f4305ad94085
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:53 2011 +0000

    tg3: Consolidate all netdev feature assignments
    
    This patch consolidates all the netdev feature bit assignments to one
    location.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit dabc5c670d3f86d15ee4f42ab38ec5bd2682487d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:52 2011 +0000

    tg3: Move TSO_CAPABLE assignment
    
    This patch moves the code that asserts the TSO_CAPABLE flag closer to
    where the TSO capabilities flags are set.  There isn't a good enough
    reason for the code to be separated.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4452d0999906e3e26b718566362e943fcaa3d694
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:51 2011 +0000

    tg3: Fix stats for 5704 and later devices
    
    Commit 4d95847381228639844c7197deb8b2211274ef22, entitled
    "tg3: Workaround rx_discards stat bug" modified the hardware statistics
    data structure.  The modification shifted the statistics so that the
    labels no longer corresponded to the counter values.  This patch fixes
    the problem by utilizing reserved space for the new counters.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 54e0a67f446fae290f99781691eba46c5cda66e7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:50 2011 +0000

    tg3: Fix TSO loopback test
    
    Commit bb158d696489244f79fd4c3abd47968a06b48c79, entitled
    "tg3: Add TSO loopback test", mistakenly inverted the checksum field
    test from the receive BD.  This patch corrects the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 42b64a450b81ec9e8cdd5b3fb13613ab9bb25048
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:49 2011 +0000

    tg3: Consolidate autoneg advertisement setup code
    
    Autonegotiation setup has gotten a little more complicated since the tg3
    driver was created.  This patch consolidates autoneg setup into one
    routine and modifies the call sites accordingly.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b0c5943f1ca4df6c1c451ef6be5287a161d29a9d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:48 2011 +0000

    tg3: Fix EEE interoperability workaround
    
    Commit 21a00ab270f95d32e502d92f166dd75c518d3c5f, entitled
    "tg3: Fix EEE interoperability issue", added an EEE interoperability
    fix.  We found that the fix doesn't work if applied too early though.
    This patch delays the fix until right before allowing LPI assertion.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 108a6c1655f184c9abb7b5917838a8fb204361f5
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:47 2011 +0000

    tg3: Fix IPv6 TCP problems for 5719
    
    Commit 4d163b75e979833979cc401ae433cb1d7743d57e, entitled
    "tg3: Fix 5719 A0 tx completion bug" turned off TSO to fix a hardware
    bug.  In doing so, it accidentally turned off all IPv6 TCP checksum
    offloading too.  This patch fixes the problem by reenabling the hardware
    bit that control both features.  The TSO capability is still not exposed
    to the kernel.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 1ff30a59f6d0c754e99442501a5145bdbbcfa6ea
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:46 2011 +0000

    tg3: Fix 57765 B0 data corruption
    
    The PCIe max FTS limit is too aggressive on these chips.  This patch
    loosens the limit a little to eliminate data corruption issues.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 432aa7ed75b3adaef6040d2cbe745fdd1c899415
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:45 2011 +0000

    tg3: Cleanup transmit error path
    
    This patch consolidates the skb cleanup code into a function named
    tg3_skb_error_unmap().  The modification addresses a long-standing bug
    where pci_unmap_single() was incorrectly being called instead of
    pci_unmap_page() in tigon3_dma_hwbug_workaround().
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2ffcc981d823a0518c627ca22d51ef72d0b7ca9a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu May 19 12:12:44 2011 +0000

    tg3: Set tx bug flags for more devices
    
    It has been recently discovered that all tg3 devices have a 4Gb boundary
    DMA problem, and that all 5755 and newer devices can't handle fragments
    less than or equal to 8 bytes in size.  This patch adjusts the flags and
    removes tg3_start_xmit().  tg3_start_xmit_dma_bug() has been renamed to
    tg3_start_xmit().
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 06c03c02ea528af0cbce50ce45ddd6a361864550
Author: Mahesh Bandewar <maheshb@google.com>
Date:   Sun May 8 06:51:48 2011 +0000

    tg3: Allow ethtool to enable/disable loopback.
    
    This patch adds tg3_set_features() to handle loopback mode. Currently the
    capability is added for the devices which support internal MAC loopback mode.
    So when enabled, it enables internal-MAC loopback.
    
    Signed-off-by: Mahesh Bandewar <maheshb@google.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7143b7d41218d4fc2ea33e6056c73609527ae687
Merge: 90864fb 87e9af6
Author: David S. Miller <davem@davemloft.net>
Date:   Thu May 5 14:59:02 2011 -0700

    Merge branch 'master' of master.kernel.org:/pub/scm/linux/kernel/git/davem/net-2.6
    
    Conflicts:
    	drivers/net/tg3.c

commit 6fdbab9d93e04bfe71f2b3fde485d092e2ffe3ec
Author: Rafael J. Wysocki <rjw@sisk.pl>
Date:   Thu Apr 28 11:02:15 2011 +0000

    tg3: Fix failure to enable WoL by default when possible
    
    tg3 is supposed to enable WoL by default on adapters which support
    that, but it fails to do so unless the adapter's
    /sys/devices/.../power/wakeup file contains 'enabled' during the
    initialization of the adapter.  Fix that by making tg3 use
    device_set_wakeup_enable() to enable wakeup automatically whenever
    WoL should be enabled by default.
    
    Signed-off-by: Rafael J. Wysocki <rjw@sisk.pl>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 707394972093e2056e1e8cc39be19cf9bcb3e7b3
Author: David Decotigny <decot@google.com>
Date:   Wed Apr 27 18:32:40 2011 +0000

    ethtool: cosmetic: Use ethtool ethtool_cmd_speed API
    
    This updates the network drivers so that they don't access the
    ethtool_cmd::speed field directly, but use ethtool_cmd_speed()
    instead.
    
    For most of the drivers, these changes are purely cosmetic and don't
    fix any problem, such as for those 1GbE/10GbE drivers that indirectly
    call their own ethtool get_settings()/mii_ethtool_gset(). The changes
    are meant to enforce code consistency and provide robustness with
    future larger throughputs, at the expense of a few CPU cycles for each
    ethtool operation.
    
    All drivers compiled with make allyesconfig ion x86_64 have been
    updated.
    
    Tested: make allyesconfig on x86_64 + e1000e/bnx2x work
    Signed-off-by: David Decotigny <decot@google.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 25db0338813a8915457636b1f6abe6a28fa73f8d
Author: David Decotigny <decot@google.com>
Date:   Wed Apr 27 18:32:39 2011 +0000

    ethtool: Use full 32 bit speed range in ethtool's set_settings
    
    This makes sure the ethtool's set_settings() callback of network
    drivers don't ignore the 16 most significant bits when ethtool calls
    their set_settings().
    
    All drivers compiled with make allyesconfig on x86_64 have been
    updated.
    
    Signed-off-by: David Decotigny <decot@google.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 63c3a66fe6c827a731dcbdee181158b295626f83
Author: Joe Perches <joe@perches.com>
Date:   Tue Apr 26 08:12:10 2011 +0000

    tg3: Convert u32 flag,flg2,flg3 uses to bitmap
    
    Using a bitmap instead of separate u32 flags allows a consistent, simpler
    and more extensible mechanism to determine capabilities.
    
    Convert bitmasks to enum.
    Add tg3_flag, tg3_flag_clear and tg3_flag_set.
    Convert the flag & bitmask tests.
    
    Signed-off-by: Joe Perches <joe@perches.com>
    Acked-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 64cad2ade1e6f890531a58318ca9ee013f92ef2f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 25 12:42:50 2011 +0000

    tg3: Update version to 3.118
    
    This patch updates the tg3 version to 3.118.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bea8a63b27eb8e705a957938aadeb975178c5ea6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 25 12:42:49 2011 +0000

    tg3: Whitespace cleanups
    
    This patch gets rid of some harmless whitespace errors.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b45aa2f6192e34a837ebdbb3548039c24440bc04
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 25 12:42:48 2011 +0000

    tg3: Add EEH support
    
    This patch adds EEH support to the tg3 driver.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bb158d696489244f79fd4c3abd47968a06b48c79
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 25 12:42:47 2011 +0000

    tg3: Add TSO loopback test
    
    This patch adds code to exercise the TSO portion of the device through
    a phy loopback test.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 00c266b794d589dcf7d280926dfc27c5896a410a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 25 12:42:46 2011 +0000

    tg3: Organize loopback test failure flags
    
    As more test modes are added to each loopback mode, the need to
    organise the results increases.  This patch groups the results by
    loopback mode, and then by test mode.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0aebff4871d26410ae485b521870bb0ffe1736f0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 25 12:42:45 2011 +0000

    tg3: Fix int generation hw bug for 5719 / 5720
    
    On the 5719 and 5720, there is a bug where the hardware will
    misinterpret a status tag update and leave interrupts permanently
    disabled.  This patch enables a hardware fix that works around the
    issue.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 470078312515f12e7cd916f1bd002acad313b9c8
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:43 2011 +0000

    tg3: Add additional EEE messaging
    
    This patch adds link messages and an item to the sign-on banner to make
    EEE status more visible.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 1d36ba450bf8c88eda57deb028370880d09a14bc
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:42 2011 +0000

    tg3: Add macro for SMDSP toggling
    
    A common AUX CTRL operation in the driver is to enable and disable the
    SMDSP.  This patch consolidates the code so that the details of the
    operation are in one place.  This patch also adds code to make sure the
    SMDSP is enabled before executing code that relies on it.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b4bd292933537e19107c3e151b27a15fefa5f8d0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:41 2011 +0000

    tg3: Add write accessor for AUX CTRL phy reg
    
    This patch adds a write accessor for the aux ctrl phy register.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 15ee95c36d355a9f47746eaa4ae8cc0ecafec550
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:40 2011 +0000

    tg3: Add read accessor for AUX CTRL phy reg
    
    This patch adds a read accessor for the aux ctrl register.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b0988c15c12c40b9680730f55a8351f30ec7a564
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:39 2011 +0000

    tg3: Move phy accessor functions higher
    
    Phy accessor functions should live closer to where the base phy read /
    write routines are.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 34eea5ac214353ccd93ef7dd8dbd10aed87f5f46
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:38 2011 +0000

    tg3: Only allow phy ioctls while netif_running
    
    When tg3 was new, phy accesses through ioctl were allowable at any time.
    Then, the driver started shutting down the phy when the device was
    closed.  Phy accesses would be allowed when the driver first attached to
    the device, but then would be forbidden after the device had been up'd
    and down'd.  After that, management firmware made it illegal to access
    the phy unless the driver "owned" the device.  Now that most firmware
    is being moved over to the APE, it is less clear when phy accesses are
    safe.
    
    While it is possible to attempt to identify these conditions and code
    the driver to navigate through the pitfalls, it could be perplexing to
    the admin why phy accesses work in some cases and not others.  This
    patch brings some uniformity to the problem by only allowing phy
    accesses while the driver has control of the device.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4a85f09831329bc5a5e4b9bca3f3ecbffb78f858
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:37 2011 +0000

    tg3: Nullify RSS for loopback test
    
    The loopback test assumes all traffic goes to the first rx queue.  There
    is a 1 in 4 chance this won't be true if RSS is enabled though.  This
    patch reprograms the RSS indirection table to route all rx packets to
    the first queue.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit eb07a9408e05f67caa671bdf2a509a4d2bd05abf
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:36 2011 +0000

    tg3: Adjust rx prod ring bd replenish thresholds
    
    The oldest tg3 devices had large rx producer ring BD caches.  Back then,
    it made sense to make the BD cache replenish threshold only a function
    of the number of rx buffers posted by the driver.  Since then, the BD
    cache sizes have shrunk to 25% of their original size and, in some
    cases, the ring sizes have quadrupled in size.  Under such conditions,
    static BD cache replenish thresholds no longer match the hardware
    constraints.
    
    This patch attempts to factor in the BD cache size into the bd cache
    replenish strategy, taking the existing hardware bugs into account.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4d95847381228639844c7197deb8b2211274ef22
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 20 07:57:35 2011 +0000

    tg3: Workaround rx_discards stat bug
    
    The 5717, 5718, 5719 A0, and 5720 A0 has a bug where the rx_discards
    statistic counter will increment when dropping unwanted multicast
    frames.  This patch works around the problem by attempting to
    recreate the data using other means.  The resulting value will not be
    accurate, but it can still serve as a problem indicator.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fce55922f5299a04c0a56b170a141fab34f13465
Author: Allan, Bruce W <bruce.w.allan@intel.com>
Date:   Wed Apr 13 13:09:10 2011 +0000

    ethtool: allow custom interval for physical identification
    
    When physical identification of an adapter is done by toggling the
    mechanism on and off through software utilizing the set_phys_id operation,
    it is done with a fixed duration for both on and off states.  Some drivers
    may want to set a custom duration for the on/off intervals.  This patch
    changes the API so the return code from the driver's entry point when it
    is called with ETHTOOL_ID_ACTIVE can specify the frequency at which to
    cycle the on/off states, and updates the drivers that have already been
    converted to use the new set_phys_id and use the synchronous method for
    identifying an adapter.
    
    The physical identification frequency set in the updated drivers is based
    on how it was done prior to the introduction of set_phys_id.
    
    Compile tested only.  Also fixes a compiler warning in sfc.
    
    v2: drivers do not return -EINVAL for ETHOOL_ID_ACTIVE
    v3: fold patchset into single patch and cleanup per Ben's feedback
    
    Signed-off-by: Bruce Allan <bruce.w.allan@intel.com>
    Cc: Ben Hutchings <bhutchings@solarflare.com>
    Cc: Sathya Perla <sathya.perla@emulex.com>
    Cc: Subbu Seetharaman <subbu.seetharaman@emulex.com>
    Cc: Ajit Khaparde <ajit.khaparde@emulex.com>
    Cc: Michael Chan <mchan@broadcom.com>
    Cc: Eilon Greenstein <eilong@broadcom.com>
    Cc: Divy Le Ray <divy@chelsio.com>
    Cc: Don Fry <pcnet32@frontier.com>
    Cc: Jon Mason <jdmason@kudzu.us>
    Cc: Solarflare linux maintainers <linux-net-drivers@solarflare.com>
    Cc: Steve Hodgson <shodgson@solarflare.com>
    Cc: Stephen Hemminger <shemminger@linux-foundation.org>
    Cc: Matt Carlson <mcarlson@broadcom.com>
    Acked-by: Jon Mason <jdmason@kudzu.us>
    Acked-by: Ben Hutchings <bhutchings@solarflare.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c3e945006ab2295e9a3f4327aa74a502ad123fe6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 13 11:05:08 2011 +0000

    tg3: Add support for extended VPD blocks
    
    In some devices, the VPD block is relocated to a different area in
    NVRAM.  The original location can still contain old, but still valid VPD
    data.  This patch changes the code to look for an extended VPD block in
    NVRAM.  If one is found, that block is used for all VPD operations
    instead.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4852a8614f63999e38539ad16615054dcd20a05d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 13 11:05:07 2011 +0000

    tg3: Add jumbo frame loopback tests to selftest
    
    This patch adds jumbo frame loopback test support to the ethtool
    selftest.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 48fa55a0a5e20b9e2a28a72c66c7027678cae6bb
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 13 11:05:06 2011 +0000

    tg3: Automatically size stat/test string arrays
    
    This patch reimplements the size preprocessor constants of the stats and
    ethtool test string arrays.  The size is calculated at compile time
    rather than using static constants.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e64de4e6c660dae6d6370b3acb59d5d5cc9ecf20
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 13 11:05:05 2011 +0000

    tg3: Dump registers when status block shows errors
    
    This patch monitors the error bit of the status word within the status
    block.  If it is set, the driver will dump the driver state after
    validating the error and then reset the chip.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 97bd8e491d1786f0020372a5a470bb8b3184856f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Apr 13 11:05:04 2011 +0000

    tg3: Provide full regdump on tx timeout
    
    The current amount of information provided in the output of a tx timeout
    is insufficient to determine a root cause.  This patch replaces the
    terse, four-register status output with a more complete body of
    information.  For PCIe devices, the full register space is dumped.  For
    other devices, select registers are dumped instead.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 1c01a80cfec6f806246f31ff2680cd3639b30e67
Merge: c44d799 4a9f65f
Author: David S. Miller <davem@davemloft.net>
Date:   Mon Apr 11 13:44:25 2011 -0700

    Merge branch 'master' of master.kernel.org:/pub/scm/linux/kernel/git/davem/net-2.6
    
    Conflicts:
    	drivers/net/smsc911x.c

commit dc668910f4eaa233c241d43d96ed6b0b9258cc43
Author: Michał Mirosław <mirq-linux@rere.qmqm.pl>
Date:   Thu Apr 7 03:35:07 2011 +0000

    net: tg3: convert to hw_features
    
    Cleanup hint: Some features are calculated in tg3_get_invariants() and
    the rest in its caller --- tg3_init_one(). This is not changed here.
    
    Signed-off-by: Michał Mirosław <mirq-linux@rere.qmqm.pl>
    Acked-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 81b8709c25e8c8f56224a24d860de7b77a772e83
Author: stephen hemminger <shemminger@vyatta.com>
Date:   Mon Apr 4 08:43:50 2011 +0000

    tg3: implement ethtool set_phys_id
    
    Implement control of LED via set_phys_id.
    Note: since PHY is powered off if device is down, this board
    only allows blinking if device is up.
    
    Signed-off-by: Stephen Hemminger <shemminger@vyatta.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 66ee33bfda6237b009b6fb0e48690e31800ff334
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:51 2011 +0000

    tg3: Support 4mb flash sizes for 5717 and 5719
    
    If a 5717 or 5719 NVRAM part is manually strapped and is 2mb in size,
    the driver needs to look at the NVRAM size field rather than infer it
    from the strapping itself.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ba1f3c76d7607a0af58834b79a055326619cbf2a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:50 2011 +0000

    tg3: Enable 5720 support
    
    This patch adds the 5720 device ID to the PCI table, thus enabling 5720
    support.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6418f2c1b57f9a5d4e7380f698635e5a445c2a50
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:49 2011 +0000

    tg3: Add 5720 PHY ID
    
    This patch adds the 5720 PHY ID.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f2096f94b514d88593355995d5dd276961e88af1
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:48 2011 +0000

    tg3: Add 5720 H2BMC support
    
    This patch adds support for the new Host to BMC feature.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9b91b5f178605dd0d4debcbc184a3e97fcb4f591
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:47 2011 +0000

    tg3: Add 5720 NVRAM decoding
    
    The 5720 implements its own NVRAM pin strapping scheme.  This patch adds
    the required support.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d78b59f5d18bf064abae2fa5bc87f00545e2160a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:46 2011 +0000

    tg3: Add 5720 ASIC rev
    
    This patch adds support for the 5720 ASIC rev.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0a58d6689bb7c0d49addbf6992aa97234bcfc96c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:45 2011 +0000

    tg3: Reintroduce 5717_PLUS
    
    This patch reintroduces the TG3_FLG3_5717_PLUS to identify 5717 and
    later devices.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 1407deb1a99f7ec7ed5b09798b02abea5aa44128
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:44 2011 +0000

    tg3: 5717_PLUS => 57765_PLUS
    
    The 57765 arrived before the 5717 and has a subset of the features
    supported by the 5717.  This patch renames the 5717_PLUS flag so that it
    can be reintroduced to designate only 5717 and later devices.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit de9f52300d03915846c2baab27332ec462f7f6b0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Apr 5 14:22:43 2011 +0000

    tg3: Cleanup extended rx ring size code
    
    Hardcoded values are used in multiple places to describe the maximum rx
    ring sizes.  This patch replaces those values with preprocessor
    constants.  This patch also introduces a new TG3_FLG3_LRG_PROD_RING_CAP
    to determine if the device is capable of supporting larger ring sizes.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 25985edcedea6396277003854657b5f3cb31a628
Author: Lucas De Marchi <lucas.demarchi@profusion.mobi>
Date:   Wed Mar 30 22:57:33 2011 -0300

    Fix common misspellings
    
    Fixes generated by 'codespell' and manually reviewed.
    
    Signed-off-by: Lucas De Marchi <lucas.demarchi@profusion.mobi>

commit ab392d2d6d4e2e50502985eead545b44ee58802c
Author: Javier Martinez Canillas <martinez.javier@gmail.com>
Date:   Mon Mar 28 16:27:31 2011 +0000

    drivers/net: Remove IRQF_SAMPLE_RANDOM flag from network drivers
    
    The IRQF_SAMPLE_RANDOM flag is marked as deprecated and will be removed.
    
    Every input point to the kernel's entropy pool have to better document the
    type of entropy source it is.
    
    drivers/char/random.c now implements a set of interfaces that can be used for
    devices to collect enviromental noise. IRQF_SAMPLE_RANDOM will be replaced
    with these add_*_randomness exported functions.
    
    Network drivers are not a good source of entropy. They use as a source of
    entropy essentially a remote host. Which means that the source of entropy can
    be potentially controlled by an attacker. Also, with heavy workloads the
    entropy decreases due to less hardware interrupts happening thanks to irq
    mitigation and NAPI.
    
    If a system relies in its network interface as a entropy source it has a false
    sense of security. Systems that don't have devices whose drivers are good
    sources of entropy, should either use a hardware random number generator or
    feed the kernel's entropy pool from userspace using other sources of entropy
    such as EGD, video_entropyd, timer_entropyd and audio-entropyd.
    
    Signed-off-by: Javier Martinez Canillas <martinez.javier@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6303e6e8da770e62a4d38f7206fe046514276d14
Author: Javier Martinez Canillas <martinez.javier@gmail.com>
Date:   Sat Mar 26 16:42:33 2011 +0000

    tg3: Fix inline keyword usage
    
    The correct usage is "static inline void" not "static void inline".
    
    Signed-off-by: Javier Martinez Canillas <martinez.javier@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 27fd9de8eb9bf48e4a09c8f02d13f56e9a074a1e
Author: Javier Martinez Canillas <martinez.javier@gmail.com>
Date:   Sat Mar 26 16:42:31 2011 +0000

    tg3: use <linux/io.h> and <linux/uaccess.h> instead <asm/io.h> and <asm/uaccess.h>
    
    It is proper style to include linux/foo.h instead asm/foo.h if both exist
    
    Signed-off-by: Javier Martinez Canillas <martinez.javier@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c5908939b2738bafe1b309bc2465cb9f2e6184c5
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Mar 9 16:58:25 2011 +0000

    tg3: Remove 5750 PCI code
    
    The 5750 ASIC rev was never released as a PCI device.  It only exists as
    a PCIe device.  This patch removes the code that supports the former
    configuration.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e256f8a35179f3795a200912b79c369676ecb669
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Mar 9 16:58:24 2011 +0000

    tg3: Move tg3_init_link_config to tg3_phy_probe
    
    This patch moves the function that initializes the link configuration
    closer to the place where the rest of the phy code is initialized.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 683644b74783725971e5ff61618bd932c5361c3f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Mar 9 16:58:23 2011 +0000

    tg3: Refine VAux decision process
    
    In the near future, the VAux switching decision process is going to get
    more complicated.  This patch refines and consolidates the existing
    algorithm in anticipation of the new scheme.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4143470c10ab5c2bbd0522efe92935416332c5e8
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Mar 9 16:58:22 2011 +0000

    tg3: cleanup pci device table vars
    
    Commit 895950c2a6565d9eefda4a38b00fa28537e39fcb, entitled
    "tg3: Use DEFINE_PCI_DEVICE_TABLE" moved two pci device tables into the
    global address space, but didn't declare them static and didn't prefix
    them with "tg3_".  This patch fixes those problems.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d4894f3ea7375dd9492b5d3d2ecb0b6e4bdb604e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Mar 9 16:58:21 2011 +0000

    tg3: Add code to verify RODATA checksum of VPD
    
    This patch adds code to verify the checksum stored in the "RV" info
    keyword of the RODATA VPD section.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 01c3a3920f9f78866420b2004602944fca45083a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Mar 9 16:58:20 2011 +0000

    tg3: Fix NVRAM selftest
    
    The tg3 NVRAM selftest actually fails when validating the checksum of
    the legacy NVRAM format.  However, the test still reported success
    because the last update of the return code was a success from the NVRAM
    reads.  This patch fixes the code so that the error return code defaults
    to a failure status.  Then the patch fixes the reason why the checsum
    validation failed.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bb18bb942a31411954021ad036ca7bace642c3c0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Mar 9 16:58:19 2011 +0000

    tg3: Add missed 5719 workaround change
    
    Commit 2866d956fe0ad8fc8d8a7c54104ccc879b49406d, entitled
    "tg3: Expand 5719 workaround" extended a 5719 A0 workaround to all
    revisions of the chip.  There was a change that should have been a
    part of that patch that was missed.  This patch adds the missing
    piece.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 43067ed8aecac4410a0a629e504629ebece35206
Author: Rafael J. Wysocki <rjw@sisk.pl>
Date:   Thu Feb 10 06:53:09 2011 +0000

    tg3: Avoid setting power.can_wakeup for devices that cannot wake up
    
    The tg3 driver uses device_init_wakeup() in such a way that the
    device's power.can_wakeup flag may be set even though the PCI
    subsystem cleared it before, in which case the device cannot wake
    up the system from sleep states.  Modify the driver to only change
    the power.can_wakeup flag if the device is not capable of generating
    wakeup signals.
    
    Signed-off-by: Rafael J. Wysocki <rjw@sisk.pl>
    Acked-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2866d956fe0ad8fc8d8a7c54104ccc879b49406d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Feb 10 20:06:46 2011 -0800

    tg3: Expand 5719 workaround
    
    As a precautionary measure, expand the fix submitted in commit
    4d163b75e979833979cc401ae433cb1d7743d57e entitled "tg3: Fix 5719 A0 tx
    completion bug" to apply to all 5719 revisions.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b86fb2cfe82fc4a555f0841f5f8ca4db303ed092
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:57 2011 +0000

    tg3: Update copyrights and update version to 3.117
    
    This patch updates copyrights and updates the tg3 version to 3.117.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d7f2ab20432441c7d4e41cd1745aafc17d712672
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:56 2011 +0000

    tg3: Fix eee preprocessor naming
    
    This patch fixes a preprocessor naming bug for one of the EEE registers.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 21a00ab270f95d32e502d92f166dd75c518d3c5f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:55 2011 +0000

    tg3: Fix EEE interoperability issue
    
    This patch fixes a problem where EEE will fail to work in certain
    environments.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ab78904608bd6e421b81420e4d2f7d5bae9d4660
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:54 2011 +0000

    tg3: Disable EEE during loopback tests
    
    EEE interferes with the hardware's ability to loop a packet back to the
    host.  This patch disables the feature for the duration of the test.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit aba49f2421d5287692aee961ab4ce2981fdf4939
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:53 2011 +0000

    tg3: Disable MAC loopback test for CPMU devices
    
    On CPMU devices, the MAC loopback test does not test any important paths
    the phy loopback test doesn't also test.  The phy loopback test is the
    more comprehensive test.  This patch disables the MAC loopback test for
    these devices.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 49692ca1e686970bac5726c3fd925427bb3ae89d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:52 2011 +0000

    tg3: Fix loopback tests
    
    The half-duplex bit in the MAC MODE register will be set during the
    loopback test if the external link is in half-duplex mode.  This will
    cause the loopback test to fail on newer devices.  This patch turns the
    half-duplex bit off for the test.
    
    Also, newer devices fail the internal phy loopback test because the phy
    link takes a little while to come up.  This patch adds code to wait for
    the link before proceeding with the test.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f746a3136a61ae535c5d0b49a9418fa21edc61b5
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:51 2011 +0000

    tg3: Restrict phy ioctl access
    
    If management firmware is present and the device is down, the firmware
    will assume control of the phy.  If a phy access were allowed from the
    host, it will collide with firmware phy accesses, resulting in
    unpredictable behavior.  This patch fixes the problem by disallowing phy
    accesses during the problematic condition.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0583d52114b19ea06d03dd2cf762a7737c265400
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:50 2011 +0000

    tg3: Disable multivec mode for 1 MSIX vector
    
    For single vector MSI-X allocations, we do not want to enable
    multivector modes.  This patch makes the necessary corrections.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bf933c802763b2beb1a1d4977f00af1a78c4fb70
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:49 2011 +0000

    tg3: Use new VLAN code
    
    This patch pivots the tg3 driver to the new VLAN infrastructure.
    All references to vlgrp have been removed.  The driver still attempts to
    disable VLAN tag stripping if CONFIG_VLAN_8021Q or
    CONFIG_VLAN_8021Q_MODULE is not defined.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4d163b75e979833979cc401ae433cb1d7743d57e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:48 2011 +0000

    tg3: Fix 5719 A0 tx completion bug
    
    The 5719 A0 has a bug that manifests itself as if the chipset were
    reordering memory writes.  The best known way to solve this problem is
    to turn off LSO and jumbo frames.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b4495ed88b782febddfa5bb99c87d75724520ecf
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 25 15:58:47 2011 +0000

    tg3: Revise 5719 internal FIFO overflow solution
    
    Commit cf79003d598b1f82a4caa0564107283b4f560e14, entitled
    "tg3: Fix 5719 internal FIFO overflow problem", proposed a way to solve
    an internal FIFO overflow problem.  We have since discovered a slightly
    better way to solve the problem.  This patch changes the code so that
    the problem is contained closer to the problem source.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit dbbe68bb12b34f3e450da7a73c20e6fa1f85d63a
Merge: 7b26e5e 9fc3bbb
Author: David S. Miller <davem@davemloft.net>
Date:   Tue Jan 4 11:57:25 2011 -0800

    Merge branch 'master' of master.kernel.org:/pub/scm/linux/kernel/git/davem/net-2.6

commit aa6027cacdd912ce884953714fcc7392b6155bc6
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Sat Jan 1 05:22:46 2011 +0000

    tg3: fix warnings
    
    In case CONFIG_PM_SLEEP is disabled, we dont need tg3_suspend() and
    tg3_resume().
    
    drivers/net/tg3.c:15056: warning: ‘tg3_suspend’ defined but not used
    drivers/net/tg3.c:15110: warning: ‘tg3_resume’ defined but not used
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    Cc: Rafael J. Wysocki <rjw@sisk.pl>
    Cc: Michael Chan <mchan@broadcom.com>
    Cc: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 824f5f38d3005c346a043dedcfe8b048b699b81a
Author: David Sterba <dsterba@suse.cz>
Date:   Wed Dec 29 03:40:31 2010 +0000

    tg3: fix return value check in tg3_read_vpd()
    
    Besides -ETIMEDOUT and -EINTR, pci_read_vpd may return other error
    values like -ENODEV or -EINVAL which are ignored due to the buggy
    check, but the data are not read from VPD anyway and this is checked
    subsequently with at most 3 needless loop iterations. This does not
    show up as a runtime bug.
    
    CC: Matt Carlson <mcarlson@broadcom.com>
    CC: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David Sterba <dsterba@suse.cz>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c866b7eac073198cef03ea6bac2dc978635a9f5c
Author: Rafael J. Wysocki <rjw@sisk.pl>
Date:   Sat Dec 25 12:56:23 2010 +0000

    tg3: Do not use legacy PCI power management
    
    The tg3 driver uses the legacy PCI power management, so it has to do
    some PCI-specific things in its ->suspend() and ->resume() callbacks,
    which isn't necessary and should better be done by the PCI
    sybsystem-level power management code.
    
    Convert tg3 to the new PCI power management framework and make it
    let the PCI subsystem take care of all the PCI-specific aspects of
    device handling during system power transitions.
    
    Tested on HP nx6325 with a NetXtreme BCM5788 adapter.
    
    Signed-off-by: Rafael J. Wysocki <rjw@sisk.pl>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 895950c2a6565d9eefda4a38b00fa28537e39fcb
Author: Joe Perches <joe@perches.com>
Date:   Tue Dec 21 02:16:08 2010 -0800

    tg3: Use DEFINE_PCI_DEVICE_TABLE
    
    Moves the PCI tables to the right read-only section.
    
    Signed-off-by: Joe Perches <joe@perches.com>

commit 23f333a2bfafba80339315b724808982a9de57d9
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Dec 12 16:45:14 2010 +0100

    drivers/net: don't use flush_scheduled_work()
    
    flush_scheduled_work() is on its way out.  This patch contains simple
    conversions to replace flush_scheduled_work() usage with direct
    cancels and flushes.
    
    Directly cancel the used works on driver detach and flush them in
    other cases.
    
    The conversions are mostly straight forward and the only dangers are,
    
    * Forgetting to cancel/flush one or more used works.
    
    * Cancelling when a work should be flushed (ie. the work must be
      executed once scheduled whether the driver is detaching or not).
    
    I've gone over the changes multiple times but it would be much
    appreciated if you can review with the above points in mind.
    
    Signed-off-by: Tejun Heo <tj@kernel.org>
    Cc: "David S. Miller" <davem@davemloft.net>
    Cc: Jay Cliburn <jcliburn@gmail.com>
    Cc: Michael Chan <mchan@broadcom.com>
    Cc: Divy Le Ray <divy@chelsio.com>
    Cc: e1000-devel@lists.sourceforge.net
    Cc: Vasanthy Kolluri <vkolluri@cisco.com>
    Cc: Samuel Ortiz <samuel@sortiz.org>
    Cc: Lennert Buytenhek <buytenh@wantstofly.org>
    Cc: Andrew Gallatin <gallatin@myri.com>
    Cc: Francois Romieu <romieu@fr.zoreil.com>
    Cc: Ramkrishna Vepa <ramkrishna.vepa@exar.com>
    Cc: Matt Carlson <mcarlson@broadcom.com>
    Cc: David Brownell <dbrownell@users.sourceforge.net>
    Cc: Shreyas Bhatewara <sbhatewara@vmware.com>
    Cc: netdev@vger.kernel.org

commit 5ee493767352314893520ac40aec5bb07d0147e0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Dec 6 08:28:54 2010 +0000

    tg3: Update version to 3.116
    
    This patch updates the tg3 version to 3.116.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a386b9011a4687470e6168e2f2a08c468f25f72f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Dec 6 08:28:53 2010 +0000

    tg3: Relax EEE thresholds
    
    The hardware defaults to fairly aggressive EEE thresholds.  While there
    appear to be no ill effects, this patch relaxes them, just as a
    precaution.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a6b68dab169e2a51e59f43504f1279cbc2afcde8
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Dec 6 08:28:52 2010 +0000

    tg3: Minor EEE code tweaks
    
    The first hunk of this patch makes sure that the driver checks for the
    appropriate preconditions before checking if EEE negotiation succeeded.
    More specifically the link needs to be full duplex for EEE to be
    enabled.
    
    The second and third hunks of this patch fix a bug where the eee
    advertisement register would be programmed with extra bits set.
    
    The fourth hunk of this patch makes sure the EEE capability flag is not
    set for 5718 A0 devices and that the device is not a serdes device.
    
    None of these modifications are strictly necessary.  The driver /
    hardware still does the right thing.  They are submitted primarily for
    correctness.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 699c019385fcb13498a5a3a8bd368f04f1d4a223
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Dec 6 08:28:51 2010 +0000

    tg3: Fix 57765 EEE support
    
    EEE support in the 57765 internal phy will not enable after a phy reset
    unless it sees that EEE is supported in the MAC.  This patch moves the
    code that programs the CPMU EEE registers to a place before the phy
    reset.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3110f5f5545a645c50ef66b1f705d08dfd1df404
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Dec 6 08:28:50 2010 +0000

    tg3: Move EEE definitions into mdio.h
    
    In commit 52b02d04c801fff51ca49ad033210846d1713253 entitled "tg3: Add
    EEE support", Ben Hutchings had commented that the EEE advertisement
    register will be in a standard location.  This patch moves that
    definition into mdio.h and changes the code to use it.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8fc2f9956127d2b85280c07e69aeb08b9bd85150
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Dec 6 08:28:49 2010 +0000

    tg3: Raise the jumbo frame BD flag threshold
    
    The current transmit routines set the jumbo frame BD flag too
    aggressively.  This can reduce performance for common cases.  This patch
    raises the jumbo flag threshold to 1518, up from 1500.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2e1e3291d4727e14c8f0f48df561afb1a5c26ffe
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Nov 24 08:31:53 2010 +0000

    tg3: Enable phy APD for 5717 and later asic revs
    
    This patch enables the gphy autopowerdown feature in the phy for all
    new devices that support it.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4bae65c892b4ff9a2797cbfa8526a5f9aaf1b2ed
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Nov 24 08:31:52 2010 +0000

    tg3: use dma_alloc_coherent() instead of pci_alloc_consistent()
    
    Using dma_alloc_coherent() permits to use GFP_KERNEL allocations instead
    of GFP_ATOMIC ones. Its better when a machine is out of memory, because
    this allows driver to sleep to get its memory and succeed its init,
    especially when allocating high order pages.
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b92b9040f6e4997b895b7b9c655a158354d28964
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Nov 24 08:31:51 2010 +0000

    tg3: Reenable TSS for 5719
    
    All TSS bugs have been fixed in the 5719.  This patch reenables the
    feature.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit deabaac8beeccdfee5358c0cd4c63258f28f3a74
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Nov 24 08:31:50 2010 +0000

    tg3: Enable mult rd DMA engine on 5719
    
    The multiple DMA read engine bugs have been fixed on the 5719.  This
    patch reenables support for this feature.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cf79003d598b1f82a4caa0564107283b4f560e14
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Nov 24 08:31:48 2010 +0000

    tg3: Fix 5719 internal FIFO overflow problem
    
    Under load, there an internal FIFO can overflow on the 5719.  The fix is
    to scale back the PCIe maximum read request size based on the current
    link speed and width.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d2394e6bb1aa636f3bd142cb6f7845a4332514b5
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Nov 24 08:31:47 2010 +0000

    tg3: Always turn on APE features in mac_mode reg
    
    The APE needs certain bits in the mac_mode register to be enabled for
    traffic to flow correctly.  This patch changes the code to always enable
    these bits in the presence of the APE.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b75cc0e4c1caac63941d96a73b2214e8007b934b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Nov 24 08:31:46 2010 +0000

    tg3: Assign correct tx margin for 5719
    
    Commit d309a46e42542223946d3a9e4e239fdc945cb53e, entitled
    "tg3: 5719: Prevent tx data corruption", was supposed to contain the tx
    margin adjustment but it looks like it somehow was omitted.  This patch
    fixes the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5093eedc8bdfd7d906836a44a248f66a99e27d22
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Nov 24 08:31:45 2010 +0000

    tg3: Apply 10Mbps fix to all 57765 revisions
    
    Commit a977dbe8445b8a81d6127c4aa9112a2c29a1a008, entitled
    "tg3: Reduce 57765 core clock when link at 10Mbps" needs to be applied
    to all revisions of the 57765 asic rev, not just the A0 revision.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f2dc0d1809ab7e0147c7e4ac837be1682f706538
Author: Rafael J. Wysocki <rjw@sisk.pl>
Date:   Mon Oct 25 13:01:55 2010 +0000

    tg3: Do not call device_set_wakeup_enable() under spin_lock_bh
    
    The tg3 driver calls device_set_wakeup_enable() under spin_lock_bh,
    which causes a problem to happen after the recent core power
    management changes, because this function can sleep now.  Fix this
    by moving the device_set_wakeup_enable() call out of the
    spin_lock_bh-protected area.
    
    Reported-by: Maxim Levitsky <maximlevitsky@gmail.com>
    Signed-off-by: Rafael J. Wysocki <rjw@sisk.pl>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2198a10b501fd4443430cb17e065a9e859cc58c9
Merge: 9941fb6 db5a753
Author: David S. Miller <davem@davemloft.net>
Date:   Thu Oct 21 08:43:05 2010 -0700

    Merge branch 'master' of master.kernel.org:/pub/scm/linux/kernel/git/davem/net-2.6
    
    Conflicts:
    	net/core/dev.c

commit eab6d18d20fc5b5ba04a7e7fcd6f357197870e51
Author: Jesse Gross <jesse@nicira.com>
Date:   Wed Oct 20 13:56:03 2010 +0000

    vlan: Don't check for vlan group before vlan_tx_tag_present.
    
    Many (but not all) drivers check to see whether there is a vlan
    group configured before using a tag stored in the skb.  There's
    not much point in this check since it just throws away data that
    should only be present in the expected circumstances.  However,
    it will soon be legal and expected to get a vlan tag when no
    vlan group is configured, so remove this check from all drivers
    to avoid dropping the tags.
    
    Signed-off-by: Jesse Gross <jesse@nicira.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7c1a96a9966efc2eb33d1021569c5ef6ae6f5ecb
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Oct 14 10:37:45 2010 +0000

    tg3: Update version to 3.115
    
    This patch updates the tg3 version to 3.115.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 64c2218266996b562a8e940a95a887fc432daced
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Oct 14 10:37:44 2010 +0000

    tg3: Report invalid link from tg3_get_settings()
    
    Currently the tg3 driver leaves the speed and duplex fields
    uninitialized in tg3_get_settings() if the device is not up.  This can
    lead to some strange deductions in certain versions of ethtool.  When
    the device is up and the link is down, the driver reports SPEED_INVALID
    and DUPLEX_INVALID for these fields.  This patch makes the presentation
    consistent by returning SPEED_INVALID and DUPLEX_INVALID when the device
    has not been brought up as well.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4803572815feea2dca9485a343a8556c9037e36e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Oct 14 10:37:43 2010 +0000

    tg3: Don't allocate jumbo ring for 5780 class devs
    
    The 5714, 5715, and 5780 devices do not have a separate rx jumbo
    producer ring.  This patch changes the code so that resources are not
    allocated for it.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f94e290eba2f98e8f759d273d9d04e8487fb4b6b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Oct 14 10:37:42 2010 +0000

    tg3: Cleanup tg3_alloc_rx_skb()
    
    src_map is no longer used in tg3_alloc_rx_skb().  Remove it.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 52b02d04c801fff51ca49ad033210846d1713253
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Oct 14 10:37:41 2010 +0000

    tg3: Add EEE support
    
    This patch adds Energy Efficient Ethernet (EEE) support for the 5718
    device ID and the 57765 B0 asic revision.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ddfc87bfd16f370904c6ff7d23738335dd68d0ce
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Oct 14 10:37:40 2010 +0000

    tg3: Add clause 45 register accessor methods
    
    This patch adds clause 45 register access methods.  They will be used in
    the following patch.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3d37728bc55994fdf2888f6c872bdeea03a84cc2
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Oct 14 10:37:39 2010 +0000

    tg3: Disable unused transmit rings
    
    This patch allows the driver to disable the additional transmit rings
    available on the 5717 and 5719 devices.  This is not strictly necessary,
    but is done anyways for correctness.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bba226acf4d13586ce47cf8376db33bed7bc0bd6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Oct 14 10:37:38 2010 +0000

    tg3: Add support for selfboot format 1 v6
    
    5718 B0 and 5719 devices will use a new selfboot firmware format.  This
    patch adds code to detect the new format so that bootcode versions get
    reported correctly.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b0057c51db66c5f0f38059f242c57d61c4741d89
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Sun Oct 10 19:55:52 2010 +0000

    tg3: restore rx_dropped accounting
    
    commit 511d22247be7 (tg3: 64 bit stats on all arches), overlooked the
    rx_dropped accounting.
    
    We use a full "struct rtnl_link_stats64" to hold rx_dropped value, but
    forgot to report it in tg3_get_stats64().
    
    Use an "unsigned long" instead to shrink "struct tg3" by 176 bytes, and
    report this value to stats readers.
    
    Increment rx_dropped counter for oversized frames.
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    CC: Michael Chan <mchan@broadcom.com>
    CC: Matt Carlson <mcarlson@broadcom.com>
    Acked-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2259dca36a2f0226596ea37132a46338fcff6722
Author: Nicolas Kaiser <nikai@nikai.net>
Date:   Thu Oct 7 23:29:27 2010 +0000

    net/tg3: simplify conditional
    
    Simplify: ((a && !b) || (!a && b)) => (a != b)
    
    Signed-off-by: Nicolas Kaiser <nikai@nikai.net>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 85407885d5d8e9eed9be8e4d33c519646b90d09f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Oct 6 13:40:58 2010 -0700

    [PATCH net-next] tg3: Set real_num_rx_queues for non-multiq devs
    
    Commit 2ddaad397c47de012dfb956b0c05540da1a0dde5 entitled "tg3: Use
    netif_set_real_num_{rx,tx}_queues()" added a new call to
    netif_set_real_num_rx_queues in tg3_enable_msix().  This call also needs
    to be added to the legacy path to correctly reflect the actual number of
    rx queues.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Acked-by: Eric Dumazet <eric.dumazet@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c7ebfdaca0b89fe9d846e93b249303313612d0e3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Sep 30 10:34:37 2010 +0000

    tg3: Update version to 3.114
    
    This patch updates the tg3 version to 3.114.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7cb32cf23c63a371cf89bfaad3f911a1609241cc
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Sep 30 10:34:36 2010 +0000

    tg3: Add extend rx ring sizes for 5717 and 5719
    
    This patch increases the rx ring sizes for those asic revs that support
    them.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2c49a44df33e22e1f48bd8d51781e7f38d55d002
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Sep 30 10:34:35 2010 +0000

    tg3: Prepare for larger rx ring sizes
    
    This patch adds two new variables to track the size of the standard and
    jumbo rx producer ring sizes.  The code is then pivoted to these
    variables from preprocessor constants.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 1da85aa3db6878639e407548dad5b2404443e2c5
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Sep 30 10:34:34 2010 +0000

    tg3: Futureproof the loopback test
    
    There are other multiqueue modes 5717 and 5719 devices can assume.  This
    patch makes sure that the loopback test is safe, should those other
    modes be enabled in the future.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 37a949c54857d8b2a38dbdc75bc8666c3292cbc4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Sep 30 10:34:33 2010 +0000

    tg3: Cleanup missing VPD partno section
    
    This patch cleans up the default VPD partno section.  New entries for
    5717 asic rev devices were also added.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f51a8903f14512f5ce61a74657db7f84f16b2717
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Sep 30 10:34:32 2010 +0000

    tg3: Remove 5724 device ID
    
    This product was never released to the public.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d309a46e42542223946d3a9e4e239fdc945cb53e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Sep 30 10:34:31 2010 +0000

    tg3: 5719: Prevent tx data corruption
    
    This patch enables a bit that prevents read DMA overflows and adjusts
    the txmbuf margin from the hardware default.  The combination of these
    modifications prevents a tx data corruption issue we were seeing on the
    5719.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 66cfd1bd05a7a1c31c9cdbb2ddf5c57d1cddc5f6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Sep 30 10:34:30 2010 +0000

    tg3: Fix potential netpoll crash
    
    Up until now the tg3 driver would call netif_napi_add() for the maximum
    number of NAPI instances the driver could use.  The problem is that
    netpoll could call tg3_poll() on instances that are not active.  The net
    effect is that the driver will crash attempting to dereference
    uninitialized pointers.
    
    The fix is to only allocate as many NAPI instances as the driver would
    use in tg3_open() and deleted them in tg3_close().
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2ddaad397c47de012dfb956b0c05540da1a0dde5
Author: Ben Hutchings <bhutchings@solarflare.com>
Date:   Mon Sep 27 22:11:51 2010 -0700

    tg3: Use netif_set_real_num_{rx,tx}_queues()
    
    Signed-off-by: Ben Hutchings <bhutchings@solarflare.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 807540baae406c84dcb9c1c8ef07a56d2d2ae84a
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Thu Sep 23 05:40:09 2010 +0000

    drivers/net: return operator cleanup
    
    Change "return (EXPR);" to "return EXPR;"
    
    return is not a function, parentheses are not required.
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f833c4c181e4e948758b7b252322f50273100d30
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 09:00:01 2010 +0000

    tg3: phy tmp variable roundup
    
    The tg3's phy routines define temporary variables in many locations
    within the same routine.  This patch unifies all temporary variables
    into one location.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a4a8bb15aed20ff74aa3ca14a4f2c0d62efd8391
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 09:00:00 2010 +0000

    tg3: Dynamically allocate VPD data memory
    
    This patch eases stack pressure by dynamically allocating the memory
    used to temporarily store VPD data.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 02e96080af2b70313f2ffc8c1b03ae2f9d8c65ac
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 08:59:59 2010 +0000

    tg3: Use skb_is_gso_v6()
    
    This patch converts the driver to prefer the skb_is_gso_v6() helper over
    the explicit inlined version.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8fea32b9555726d35b91492d17fc21c7874d36f9
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 08:59:58 2010 +0000

    tg3: Move producer ring struct to tg3_napi
    
    Now that each NAPI instance has its own producer ring, it no longer
    makes sense to keep the producer ring structure external.  This patch
    migrates the producer ring struct to tg3_napi and pivots the code to the
    new implementation.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6fd45cb814709767a1704b541aa91647b7f275cf
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 08:59:57 2010 +0000

    tg3: Clarify semantics of TG3_IRQ_MAX_VECS
    
    TG3_IRQ_MAX_VECS should be seen as the maximum number of vectors that
    any device could be expected to use.  tp->irq_max represents the maximum
    number of vectors the current device can use.  This patch clarifies the
    semantics of the code to match the above description.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2e9f7a7408d264f01d4477c564ef5c6b610cd10f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 08:59:56 2010 +0000

    tg3: Unlock 5717 B0+ support
    
    This patch adjusts the driver to use the tg3_start_xmit_dma_bug()
    transmit routine for all revisions of 5717 asic rev devices and then
    allows the driver to attach to B0 and later devices.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit dc6d074457f1551f9357f773a4eda09a3d5ef150
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 08:59:55 2010 +0000

    tg3: Don't send APE events for NCSI firmware
    
    NCSI firmware does not accept APE events.  It relies on a "driver state"
    location in shared memory to tell it what the driver's current state is.
    
    This patch pivots the code to use the new driver state scheme.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f0392d24485e4c144d2741a5424f069b8b5f30e7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 08:59:54 2010 +0000

    tg3: Disable TSS
    
    It was recently discovered that enabling TSS can lockup the device.
    This patch disables the feature until a suitable workaround can be
    found.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 41a8a7ee4a78216962f3afcea5968c04d0ab3b08
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Sep 15 08:59:53 2010 +0000

    tg3: Fix read DMA FIFO overruns on recent devices
    
    Earlier versions of tg3 devices had a problem where the read DMA FIFO
    could be overrun in certain edge conditions.  The fix was to limit the
    number of rx BDs the hardware would fetch at a time.  For later devices
    (5761, 5784 and later ASIC revs), there is a hardware fix that must be
    enabled to fix the same problem.  This patch adds that hardware fix.
    
    There is a gap in the ASIC revision lineage where neither fix is
    applied.  This is intentional as these ASIC revisions are not afflicted
    by the bug.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bc8acf2c8c3e43fcc192762a9f964b3e9a17748b
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Thu Sep 2 13:07:41 2010 -0700

    drivers/net: avoid some skb->ip_summed initializations
    
    fresh skbs have ip_summed set to CHECKSUM_NONE (0)
    
    We can avoid setting again skb->ip_summed to CHECKSUM_NONE in drivers.
    
    Introduce skb_checksum_none_assert() helper so that we keep this
    assertion documented in driver sources.
    
    Change most occurrences of :
    
    skb->ip_summed = CHECKSUM_NONE;
    
    by :
    
    skb_checksum_none_assert(skb);
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9ed6eda4fad9ea95e99f1e3cc546bcde049695cf
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:08 2010 +0000

    tg3: Update version to 3.113
    
    This patch updates the tg3 version to 3.113.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f07e9af31e6e1bf2a499e1f52cbf0982619fa611
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:07 2010 +0000

    tg3: Migrate tg3_flags to phy_flags
    
    This patch moves most of the phy related flag definitions over to the
    phyflags member and changes the code accordingly.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 80096068bc21420ba4d690341a3c70c49017d167
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:06 2010 +0000

    tg3: Create phy_flags and migrate phy_is_low_power
    
    This patch deletes the link_config.phy_is_low_power flag and creates a
    new phy_flags device member to store all phy related settings.  All the
    code is converted accordingly.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f08aa1a8b8ff0738d42936c3ac8c5516848bca02
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:05 2010 +0000

    tg3: Add phy-related preprocessor constants
    
    This patch replaces some instances of hardcoded phy register values with
    preprocessor equivalents.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6ee7c0a0a5003abd4afd724f5c2f654fe7328c0a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:04 2010 +0000

    tg3: Add error reporting to tg3_phydsp_write()
    
    This patch adds error reporting to the tg3_phydsp_write() function and
    converts a few more locations to use this function over the inlined
    equivalent.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f65aac166fe10b96e64c233980a3522fc50fbecf
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:03 2010 +0000

    tg3: Improve small packet performance
    
    smp_mb() inside tg3_tx_avail() is used twice in the normal
    tg3_start_xmit() path (see illustration below).  The full memory
    barrier is only necessary during race conditions with tx completion.
    We can speed up the tx path by replacing smp_mb() in tg3_tx_avail()
    with a compiler barrier.  The compiler barrier is to force the
    compiler to fetch the tx_prod and tx_cons from memory.
    
    In the race condition between tg3_start_xmit() and tg3_tx(),
    we have the following situation:
    
    tg3_start_xmit()                       tg3_tx()
        if (!tg3_tx_avail())
            BUG();
    
        ...
    
        if (!tg3_tx_avail())
            netif_tx_stop_queue();         update_tx_index();
            smp_mb();                      smp_mb();
            if (tg3_tx_avail())            if (netif_tx_queue_stopped() &&
                netif_tx_wake_queue();         tg3_tx_avail())
    
    With smp_mb() removed from tg3_tx_avail(), we need to add smp_mb() to
    tg3_start_xmit() as shown above to properly order netif_tx_stop_queue()
    and tg3_tx_avail() to check the ring index.  If it is not strictly
    ordered, the tx queue can be stopped forever.
    
    This improves performance by about 3% with 2 ports running
    bi-directional 64-byte packets.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 67b284d476bcb3d100e946da23d6cf9acfd0465c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:02 2010 +0000

    tg3: Remove 5720, 5750, and 5750M
    
    These devices were never released to the public.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ecc796486f0a7f4958f8dc7550267570dcacb608
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:01 2010 +0000

    tg3: Detect APE firmware types
    
    This patch adds code to determine the APE firmware type and report this
    along with the firmware version.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8c69b1e702527e39c0b4fbda79d2738d186a3908
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:26:00 2010 +0000

    tg3: Restrict ASPM workaround devlist
    
    The ASPM workaround setting obtained from NVRAM only works with devices
    older than 5717.  This patch enforces the restriction.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f37500d3f66ba82888315838278d56fc27308327
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:25:59 2010 +0000

    tg3: Manage gphy power for CPMU-less devs only
    
    This patch changes the code to only manage the PCIe gphy power for
    CPMU-less devices only.  The CPMU takes over management for newer
    chips.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 88075d915b51d9a17cc7436c868013a3113a849a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:25:58 2010 +0000

    tg3: Don't access phy test ctrl reg for 5717+
    
    The phy test register location has been repurposed for 5717+ devices.
    This patch changes the code to avoid this location for these devices.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c885e824699f49bc3758a0dec760e189cd774e79
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:25:57 2010 +0000

    tg3: Create TG3_FLG3_5717_PLUS flag
    
    This patch creates a TG3_FLG3_5717_PLUS flag to collectively describe
    the set of changes in the ASIC that will apply to all future chip
    revisions.
    
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 774ee7525ff94e597844c9f7f6a48938906df698
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:25:56 2010 +0000

    tg3: Disable TSS also during tg3_close()
    
    The TSS flag needs to be turned off during tg3_close().  If the device
    fails to allocate more than one MSI-X vector the next time the device is
    brought up, transmits will fail.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6de34cb963a934953fdd365937b4b75959256602
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 2 11:25:55 2010 +0000

    tg3: Add 5784 ASIC rev to earlier PCIe MPS fix
    
    tg3 commit e7126997342560533317d8467e8516119ebcbd21 entitled
    "tg3: Preserve PCIe MPS setting for new devs" attempted to ensure the
    PCIe link negotiated Maximum Payload Size (MPS) setting was 128 bytes
    for all devices that didn't support higher speeds.  The 5784 device was
    mistakenly added to this list when it shouldn't have.  This patch
    removes the 5784 ASIC rev devices from that list.
    
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 28b041139e344ecd0f144d6205b004ae354cfa1e
Author: Richard Cochran <richardcochran@gmail.com>
Date:   Sat Jul 17 08:48:55 2010 +0000

    net: preserve ifreq parameter when calling generic phy_mii_ioctl().
    
    The phy_mii_ioctl() function unnecessarily throws away the original ifreq.
    We need access to the ifreq in order to support PHYs that can perform
    hardware time stamping.
    
    Two maverick drivers filter the ioctl commands passed to phy_mii_ioctl().
    This is unnecessary since phylib will check the command in any case.
    
    Signed-off-by: Richard Cochran <richard.cochran@omicron.at>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 98e32a9ceea8e3a0cd6ea89c9ce8e09a74b03b78
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Jul 11 09:31:47 2010 +0000

    tg3: Update version to 3.112
    
    This patch updates the tg3 version to 3.112.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit be98da6a10f3e7f855f36f3fdd67a91366cabc1c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Jul 11 09:31:46 2010 +0000

    tg3: Fix some checkpatch errors
    
    This patch fixes the following checkpatch errors:
    
    ERROR: do not use assignment in if condition
    +	if ((mss = skb_shinfo(skb)->gso_size) != 0) {
    
    ERROR: do not use assignment in if condition
    +	if ((mss = skb_shinfo(skb)->gso_size) != 0) {
    
    ERROR: space prohibited after that '!' (ctx:BxW)
    +			if (! netif_carrier_ok(tp->dev) &&
     			    ^
    
    ERROR: space required after that ',' (ctx:VxV)
    +#define GET_REG32_LOOP(base,len)		\
                                ^
    
    ERROR: "(foo*)" should be "(foo *)"
    +		memcpy(data, ((char*)&val) + b_offset, b_count);
    
    ERROR: do not use assignment in if condition
    +		if ((err = tg3_do_mem_test(tp, mem_tbl[i].offset,
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 702e52ccd32164a09ea91aa5896ad7c64cb708cb
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Jul 11 09:31:45 2010 +0000

    tg3: Revert PCIe tx glitch fix
    
    This patch reverts commit 52cdf8526fe24f11d300b75458ddee017f3f4c88,
    entitled "tg3: Prevent a PCIe tx glitch".  The problem does not have
    any visible side-effects and happens too early for the driver to do
    anything about it.  The proper place for this code is within the
    device's bootcode.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6867c843813a801d5f568b6fb006695316714f1b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Jul 11 09:31:44 2010 +0000

    tg3: Report driver version to firmware
    
    This patch changes the code so that the driver version can be reported
    to the firmware in addition to the current use.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2138c002173abe3e439e213e5cc03b385b20508c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Jul 11 09:31:43 2010 +0000

    tg3: Relax 5717 serdes restriction
    
    tg3 is coded to refuse to attach to 5717 serdes devices.  Now that the
    hardware is better supported, we can relax this restriction.  This patch
    also fixes a recently introduced bug which will cause serdes parallel
    detection not to work with 5780 class devices.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 34195c3dce84fd0ee47f4131584ff1f6f283b93c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Jul 11 09:31:42 2010 +0000

    tg3: Fix IPv6 TSO code in tg3_start_xmit_dma_bug()
    
    The tg3_start_xmit_dma_bug() function was missing code to process IPv6
    TSO packets.  This patch adds the missing support.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 20d7375c1fdf054ca8ab9e5b9fe7fe62b39fa218
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Jul 11 09:31:41 2010 +0000

    tg3: Fix single MSI-X vector coalescing
    
    The interrupt coalescing setup code used the TG3_FLG2_USING_MSIX flag to
    determine whether or not to configure the rx coalescing parameters.
    This is incorrect for the single MSI-X vector case.  This patch changes
    the code to look at the TG3_FLG3_ENABLE_RSS instead.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5efeeea1cf16b6382e1a9e2e389950024ba17f3e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Jul 11 09:31:40 2010 +0000

    tg3: Revert RSS indir tbl setup change
    
    This patch reverts commit 2601d8a0049c8b5d29cd5adb844a305a804e505f.  A
    spectacular set of coincidences made it look as though the table was
    setup incorrectly.  The original version was correct.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7fe876af921d1d2bc8353e0062c10ff35e902653
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Thu Jul 8 06:14:55 2010 +0000

    tg3: allow TSO on vlan devices
    
    Similar to commit 72dccb01e8632aa (bnx2: Update vlan_features)
    
    In order to enable TSO on vlan devices, tg3 needs to update
    dev->vlan_features.
    
    Tested on HP NC326m (aka BCM5715S (rev a3))
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 511d22247be767bbf275ee7a5a388c4f009aa0c1
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Wed Jul 7 20:44:24 2010 +0000

    tg3: 64 bit stats on all arches
    
    Now core network is able to handle 64 bit netdevice stats on 32 bit
    arches, we can provide them for tg3, since hardware maintains 64 bit
    counters.
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 83038a2a7062f6cbbdcfaff47284566f060a5af1
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:39 2010 +0000

    tg3: Update version to 3.111
    
    This patch updates the tg3 version to 3.111.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 302b500b27dda8e07b3cb967ff588de84ee87ba4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:38 2010 +0000

    tg3: Add 5719 PCI device and phy IDs
    
    This patch adds the 5719 PCI device and phy IDs.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a50d0796b09ad909a25fc75e54eec7f713edeba8
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:37 2010 +0000

    tg3: Add 5719 ASIC rev
    
    This patch adds the 5719 ASIC revision.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9c7df9157889a8f67d2d104fd52f2aacb3826fe7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:36 2010 +0000

    tg3: Use devfn to determine function number
    
    The driver sometimes needs to know which function number the current
    device is.  This patch changes the code to use devfn over internal
    register values.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 57d8b88030ca9f295bb72ef65228c6d86bed22f6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:35 2010 +0000

    tg3: 5717: Allow serdes link via parallel detect
    
    The 5717 serdes phy brings link up via parallel detection without any
    additional help from the driver.  This patch changes the
    tg3_setup_fiber_mii_phy() function to detect and allow the use of this
    feature.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2430b031be8d3eb57f22f2df6fb3784564109db0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:34 2010 +0000

    tg3: Allow single MSI-X vector allocations
    
    This patch changes the code to make it legal to allocate only one MSI-X
    vector.  It also fixes a bug where the driver was not checking for error
    return codes from pci_enable_msix().
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2601d8a0049c8b5d29cd5adb844a305a804e505f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:33 2010 +0000

    tg3: Off-by-one error in RSS setup
    
    The driver was incorrectly programming the indirection table such that
    rx traffic intended for the second ring went to the first ring, rx
    traffic intended for the third ring went to the second ring, etc.  This
    patch changes the code so that rx traffic is diverted to the proper
    ring.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b28f6428af279ffb9e97ee00486a29498b7fcfdc
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:32 2010 +0000

    tg3: Fix a memory leak on 5717+ devices
    
    The rx resources for MSI-X interrupt vector 0 were not being freed
    correctly.  This happens because the teardown loop continue's to the
    next loop iteration if it detects the tx ring for that vector is not
    setup, thus bypassing the rx teardown code.  This patch moves the
    call to tg3_rx_prodring_free() earlier in the loop.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b1d0521059789a138d19c4f940d6eca7d620a6eb
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:31 2010 +0000

    tg3: Avoid tx lockups on 5755+ devices
    
    In certain edge conditions, internal tx resources can get corrupted.
    This patch enables a bit that will fix the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f92d9dc1504a964acfe07e8036fa30dcef22d343
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sat Jun 5 17:24:30 2010 +0000

    tg3: Relocate APE mutex regs for 5717+
    
    The 5717 and later devices relocate the APE mutex registers.  This patch
    organizes the code so that the driver can use the mutex registers in the
    old and new locations.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e1703b36c358dde24ececba4fd609ecd91433ba3
Merge: 7ec75c5 e95ef5d
Author: David S. Miller <davem@davemloft.net>
Date:   Tue Apr 27 12:49:13 2010 -0700

    Merge branch 'master' of master.kernel.org:/pub/scm/linux/kernel/git/davem/net-2.6
    
    Conflicts:
    	drivers/net/e100.c
    	drivers/net/e1000e/netdev.c

commit dc8bf1b1a6edfc92465526de19772061302f0929
Author: Andre Detsch <adetsch@br.ibm.com>
Date:   Mon Apr 26 07:27:07 2010 +0000

    tg3: Fix INTx fallback when MSI fails
    
    tg3: Fix INTx fallback when MSI fails
    
    MSI setup changes the value of irq_vec in struct tg3 *tp.
    This attribute must be taken into account and restored before
    we try to do a new request_irq for INTx fallback.
    
    In powerpc, the original code was leading to an EINVAL return within
    request_irq, because the driver was trying to use the disabled MSI
    virtual irq number instead of tp->pdev->irq.
    
    Signed-off-by: Andre Detsch <adetsch@br.ibm.com>
    Acked-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cb903bf4ee2d6e53210e2174d363e10698112042
Author: David S. Miller <davem@davemloft.net>
Date:   Tue Apr 20 18:49:45 2010 -0700

    tg3: Enable GRO by default.
    
    This was merely an oversight when I added the *_gro_receive()
    calls.
    
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4e5e4f0d65975ce092202cce48b42571bf84591e
Author: FUJITA Tomonori <fujita.tomonori@lab.ntt.co.jp>
Date:   Mon Apr 12 14:32:09 2010 +0000

    tg3: use the DMA state API instead of the pci equivalents
    
    This replace the PCI DMA state API (include/linux/pci-dma.h) with the
    DMA equivalents since the PCI DMA state API will be obsolete.
    
    No functional change.
    
    For further information about the background:
    
    http://marc.info/?l=linux-netdev&m=127037540020276&w=2
    
    Signed-off-by: FUJITA Tomonori <fujita.tomonori@lab.ntt.co.jp>
    Cc: Matt Carlson <mcarlson@broadcom.com>
    Cc: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3941f1885bbf5b9f5e45cdd5a82efc794cc3823f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 12 06:58:31 2010 +0000

    tg3: Update version to 3.110
    
    This patch updates the tg3 version to 3.110.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit de6f31eb9a467cfd0f1f8c5e6ca842563f7f2870
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 12 06:58:30 2010 +0000

    tg3: Remove function errors flagged by checkpatch
    
    This patch removes the following checkpatch errors:
    
    * return is not a function, parentheses are not required
    * space prohibited between function name and open parenthesis '('
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 04380d401ebd02ec68bb0fc170f21a93690ebc80
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 12 06:58:29 2010 +0000

    tg3: Unify max pkt size preprocessor constants
    
    The maximum packet size that gets programmed into the standard producer
    ring control block is directly related to the packet size used to
    allocate packet buffers.  This patch removes the redundant preprocessor
    constant.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9dc7a1134919bda8951bf5909fb79c14defb8317
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 12 06:58:28 2010 +0000

    tg3: Re-inline VLAN tags when appropriate
    
    The tg3 driver is written so that VLAN tagged packets can be accepted,
    even if CONFIG_VLAN_8021Q or CONFIG_VLAN_8021Q_MODULE is not defined.
    (Think raw interfaces.)  If the device has ASF support enabled, the
    firmware requires the driver to enable VLAN tag stripping.  If VLAN
    tagging is not explicitly supported by the kernel and ASF is enabled,
    the driver will have to reinject the VLAN tag back into the packet
    stream.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d2757fc4076118e13180e91f02c3c52659be3d9d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 12 06:58:27 2010 +0000

    tg3: Optimize rx double copy test
    
    On a PCIX bus, the 5701 has a bug which requires the driver to double
    copy all rx packets.  The rx code uses the rx_offset device member as a
    flag to determine if this workaround should take effect.  The following
    patch will modify the rx_offset member such that this test will become
    less clear.
    
    The patch starts by integrating the workaround check into the packet
    length check.  It rounds out the implementation by relaxing the
    workaround restrictions if the platform has efficient unaligned
    accesses.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a977dbe8445b8a81d6127c4aa9112a2c29a1a008
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 12 06:58:26 2010 +0000

    tg3: Reduce 57765 core clock when link at 10Mbps
    
    This patch reduces the core clock to 6.25MHz when operating at 10Mbps
    link speed.  This is needed to prevent a bug that will ultimately cause
    transmits to cease.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 1a3190254c0d1d1951e1d7e93542387c6ec82384
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 12 06:58:25 2010 +0000

    tg3: Set card 57765 card reader MRRS to 1024B
    
    This patch sets the Maximum Read Request Size for the card reader
    function to 1024 bytes to prevent an SD controller lockup.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cea46462681d61a65a208d17206d38739c1ea1b1
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 12 06:58:24 2010 +0000

    tg3: Disable CLKREQ in L2
    
    This patch disables CLKREQ in L2 to workaround a chipset bug.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7ae554e5557bc8ee6ced437e5acffba922463a63
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:30 2010 +0000

    tg3: Update version to 3.109
    
    This patch updates the tg3 version to 3.109.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7705736f5fc2e8fd0aa98eb7667e65dbedf50d63
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:29 2010 +0000

    tg3: Remove tg3_dump_state()
    
    The tg3_dump_state() function is commented out and doesn't get used much
    when debugging efforts are underway.  The chip architecture has also
    changed enough that any debugging effort that might use it would have to
    tailor it to the capabilities of the hardware.  This patch just removes
    the function entirely.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 859a58879d7c771e78a373028d719467a2f8feb7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:28 2010 +0000

    tg3: Cleanup if codestyle
    
    This patch cleans up the code style as it pertains to if statements.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 33f401aec709e4fea414e5a4cf81b96462bc224f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:27 2010 +0000

    tg3: The case of switches
    
    This patch fixes checkpatch errors related to switch statements.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c6cdf43631c4108b38b872136c926691e987880f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:26 2010 +0000

    tg3: Whitespace, constant, and comment updates
    
    This patch fixes whitespace errors, preprocessor definition placement
    oddities and updates comments.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 184b89044fb6e2a74611dafa69b1dce0d98612c6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:25 2010 +0000

    tg3: Use VPD fw version when present
    
    This patch extracts the firmware version from the VPD area and changes
    the code to prefer that version version over the manually extracted
    version.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 75f9936e1150be739a9f6577a9d34de120ea35f1
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:24 2010 +0000

    tg3: Prepare FW version code for VPD versioning
    
    The code that extracts the firmware version from the device's NVRAM
    assumes the firmware version member is a clean slate.  The following
    patch will add code to extract the firmware version from the VPD area
    of NVRAM, so this assumption will no longer be true.  This patch adjusts
    the versioning code to respect the VPD version if it exists.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5129c3a3faf8c5f4e6dd6ca581e1c4b06f8e837f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:23 2010 +0000

    tg3: Fix message 80 char violations
    
    Commit 05dbe005386e7521153dce6c5ad95c98b73b80c7, "Use (pr|netdev)_<level>
    macro helpers" extended some of the message lines longer than 80 chars.
    This patch reels the line lengths back in.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ab96b241fd82ec8d546684ab6e29b6530976780a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:22 2010 +0000

    tg3: netdev_err() => dev_err()
    
    Some uses of netdev_err() happen before the device has been registered.
    This will cause the messages to be prepended with "(unregistered
    net_device)" strings.  We can clean up the message by using dev_err()
    instead.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2445e461ce8c5a2316ed4c8a45cd2d0b6a366310
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:21 2010 +0000

    tg3: Replace pr_err with sensible alternatives
    
    All the instances of pr_err() in the tg3 driver have better
    alternatives.  This patch replaces all pr_err() calls.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6d40db7beaef823621ff3d340ef53d08445960b4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 5 10:19:20 2010 +0000

    tg3: Restore likely() check in tg3_poll_msix()
    
    When creating the new tg3_poll_msix() function, the likely() compiler
    hint was dropped.  This patch reintroduces it.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 22bedad3ce112d5ca1eaf043d4990fa2ed698c87
Author: Jiri Pirko <jpirko@redhat.com>
Date:   Thu Apr 1 21:22:57 2010 +0000

    net: convert multicast list to list_head
    
    Converts the list and the core manipulating with it to be the same as uc_list.
    
    +uses two functions for adding/removing mc address (normal and "global"
     variant) instead of a function parameter.
    +removes dev_mcast.c completely.
    +exposes netdev_hw_addr_list_* macros along with __hw_addr_* functions for
     manipulation with lists on a sandbox (used in bonding and 80211 drivers)
    
    Signed-off-by: Jiri Pirko <jpirko@redhat.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3f07d1295191cfa41125e4e61ee2064790070071
Author: Julia Lawall <julia@diku.dk>
Date:   Sat Mar 13 12:22:16 2010 -0800

    drivers/net/tg3.c: change the field used with the TG3_FLAG_10_100_ONLY constant
    
    The constant TG3_FLAG_10_100_ONLY should be used with the tg3_flags field,
    not the tg3_flags2 field, as done elsewhere in the same file.
    
    Signed-off-by: Julia Lawall <julia@diku.dk>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fe234f0e5cbb880792d2d1ac0743cf8c07e9dde3
Author: Louis Rilling <Louis.Rilling@kerlabs.com>
Date:   Tue Mar 9 06:14:41 2010 +0000

    tg3: Fix tg3_poll_controller() passing wrong pointer to tg3_interrupt()
    
    Commit 09943a1819a240ff4a72f924d0038818fcdd0a90
    	Author: Matt Carlson <mcarlson@broadcom.com>
    	Date:   Fri Aug 28 14:01:57 2009 +0000
    
    	tg3: Convert ISR parameter to tnapi
    
    forgot to update tg3_poll_controller(), leading to intermittent crashes with
    netpoll.
    
    Fix this.
    
    Signed-off-by: Louis Rilling <louis.rilling@kerlabs.com>
    Cc: stable@kernel.org
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4181b2c8bc29bb756ac1816678104b528377b656
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 26 14:04:45 2010 +0000

    tg3: Remove now useless VPD code
    
    Now that the VPD searching code is abstracted away, the outer loop used
    to detect the read-only large resource data type section is useless.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Acked-by: Jesse Barnes <jbarnes@virtuousgeek.org>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4067a8541d397e9d6b443dd2ce0ecb78bfd991db
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 26 14:04:43 2010 +0000

    pci: Add helper to search for VPD keywords
    
    This patch adds the pci_vpd_find_info_keyword() helper function to
    find information field keywords within read-only and read-write large
    resource data type sections.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Acked-by: Jesse Barnes <jbarnes@virtuousgeek.org>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e1d5bdabb94da89bdb3c3f2ee105cf61fca88ec8
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 26 14:04:42 2010 +0000

    pci: Add VPD information field helper functions
    
    This patch adds a preprocessor constant to describe the PCI VPD
    information field header size and an inline function to extract the
    size of the information field itself.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Acked-by: Jesse Barnes <jbarnes@virtuousgeek.org>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b55ac1b22690d2e5b02a61cf6d69c2d66969c79d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 26 14:04:41 2010 +0000

    pci: Add helper to find a VPD resource data type
    
    This patch adds the pci_vpd_find_tag() helper function to find VPD
    resource data types in a buffer.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Acked-by: Jesse Barnes <jbarnes@virtuousgeek.org>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7ad506fa1adc2da3d394c562f09b8e1b3026c402
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 26 14:04:40 2010 +0000

    pci: Add large and small resource data type code
    
    This patch introduces more VPD preprocessor definitions to identify some
    small and large resource data type item names.  The patch then continues
    to correct how the tg3 and bnx2 drivers search for the "read-only data"
    large resource data type.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Acked-by: Jesse Barnes <jbarnes@virtuousgeek.org>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a2ce766238f72ff7337606c0bc96803c30c9e05c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 26 14:04:39 2010 +0000

    pci: Add PCI LRDT tag size and section size
    
    This patch adds a preprocessor constant to describe the PCI VPD large
    resource data type tag size and an inline function to extract the large
    resource section size from the large resource data type tag.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Acked-by: Jesse Barnes <jbarnes@virtuousgeek.org>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 567ec874d15b478c8eda7e9a5d2dcb05f13f1fb5
Author: Jiri Pirko <jpirko@redhat.com>
Date:   Tue Feb 23 23:17:07 2010 +0000

    net: convert multiple drivers to use netdev_for_each_mc_addr, part6
    
    Signed-off-by: Jiri Pirko <jpirko@redhat.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 05dbe005386e7521153dce6c5ad95c98b73b80c7
Author: Joe Perches <joe@perches.com>
Date:   Wed Feb 17 19:44:19 2010 +0000

    drivers/net/tg3.c: Use (pr|netdev)_<level> macro helpers
    
    Add #define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
    Remove #define PFX
    Use pr_<level>
    Use netdev_<level>
    Remove periods from most formats
    Coalesce long formats
    Use printk_once
    
    Signed-off-by: Joe Perches <joe@perches.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit be7ce5307ded2e416224baab0bd1e5072591f33f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:17:05 2010 +0000

    tg3: Update version to 3.108
    
    This patch updates the tg3 version to 3.108.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6a443a0f72ad7706345412dbd2e4d4981fdfce39
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:17:04 2010 +0000

    tg3: Push phylib definitions to phylib
    
    This patch pushes phylib definitions out to phylib headers.  For phy
    IDs, this removes some code duplication.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 79eb6904361fe4e54e589919a9b62c5e036c42c3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:17:03 2010 +0000

    tg3: Rename tg3 phy ID preprocessor definitions
    
    The phylib presents the phy ID in a different format than the one tg3
    has traditionally used.  To highlight the distinction, this patch
    prepends the tg3 native phy ID format with TG3.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 24daf2b0a4005f3a4e757752fcfed9da276cf202
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:17:02 2010 +0000

    tg3: Reformat SSID to phy ID table
    
    This patch reformats the SSID to phy ID table, replacing constants with
    preprocessor definitions.  This patch is also prep work for the
    following patch, which will push line lengths beyond 80 chars.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9ea4818dd39cc8c6b31c38c9f51d19d5d4ee0be6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:17:01 2010 +0000

    tg3: Discover phy address once
    
    The phy address will not change after it has been identified.  Move the
    discovery code to a location that only gets executed once.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0d86df808886d4e56c46a9c356dfb81146e3b6d1
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:17:00 2010 +0000

    tg3: Reduce indent level of tg3_rx_prodring_alloc
    
    This patch adds an inverted "jumbo ring enable" test and jumps to the exit
    if it succeeds.  The change reduces the indent level of the remaining
    code making it more readable.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 144170635b543ceadfe6ba907ac496b40795764e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:16:59 2010 +0000

    tg3: Rename TG3_FLG3_RGMII_STD_IBND_DISABLE
    
    The STD part of this preprocessor definition is a bit of a misnomer.
    This flag is a coarse control of the RGMII inband status facilities.
    This patch renames the definition to be more accurate.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b474eca74cf647df0a7fd56bc975ee4a812741b7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:16:58 2010 +0000

    tg3: Add more partno entries for fallback path
    
    This patch adds 57765 asic partno entries for the path executed if VPD
    is not present in NVRAM.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2712168f856e8cd42265e7ef855d64702da20089
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:16:57 2010 +0000

    tg3: Allow phylib flowctrl changes anytime
    
    This patch loosens the restriction that the phylib interface must be up
    and running to change the flow control parameters.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a4153d401ac440c73e0721db0b6b031e8e6f77d1
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:16:56 2010 +0000

    tg3: Add support for 2 new selfboot formats
    
    This patch adds new offsets to the bootcode version extraction code to
    support NVRAM format versions 4 and 5.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d110114281fad580dd9ce629507d17b123169cff
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:16:55 2010 +0000

    tg3: Make 57791 and 57795 10/100 only
    
    This patch adds the 57791 and 57795 to the list of devices that only
    support 10 and 100 Mbps speeds.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 61e800cf949926b3d463ca3cf3025d964872774b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 17 15:16:54 2010 +0000

    tg3: Enforce DMA mapping / skb assignment ordering
    
    Michael Chan noted that there is nothing in the code that would prevent
    the compiler from delaying the access of the "mapping" member of the
    newly arrived packet until much later.  If this happened after the
    skb = NULL assignment, it is possible for the driver to pass a bad
    dma_addr value to pci_unmap_single().  To enforce this ordering, we need
    a write memory barrier.  The pairing read memory barrier already exists
    in tg3_rx_prodring_xfer() under the comments starting with
    "Ensure that updates to the...".
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b3b3f04fb587ecb61b5baa6c1c5f0e666fd12d73
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:13 2010 +0000

    tg3: Update driver version to 3.107
    
    This patch updates the tg3 version to 3.107.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 1061b7c56482310bbb8197045d51e2986afabfce
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:12 2010 +0000

    tg3: Fix AC131 loopback test errors for 5785
    
    The AC131 does not enable the forced transmit clock settings
    immediately.  The workaround is to read the register again to get the
    setting to take effect.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c88734054e787542ea093b02120e324e92cad882
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:11 2010 +0000

    tg3: Fix napi assignments in loopback test
    
    The 57765 lacks TSS support.  This renders the napi assignments
    incorrect in the loopback test function.  This patch fixes the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 603f11738cee4d46a2a1d394ae80d718f8d37cba
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:10 2010 +0000

    tg3: Reset phy during bringup when using phylib
    
    The driver puts the phy into low-power mode when it releases the device.
    If the device were to be reacquired, the phy needs a reset to bring it
    back to full powered operation.  This patch allows phylib-enabled
    devices to reset the phy.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0339e4e3effeae71e2b19c6340ef9672fb7a2cb3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:09 2010 +0000

    tg3: Turn off multiple DMA reads for 5717
    
    The 5717's DMA read engine has a bug when initiating multiple DMA reads
    across the PCIe bus.  This patch disables the feature.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6b10c1653e425e30cff7f41d0e6f9743bfa9810f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:08 2010 +0000

    tg3: Fix 57765 A0 bootcode race condition
    
    On A0 revision of 57765 asic rev devices, the bootcode will perform some
    hardware operations, after the magic signature is presented, that will
    collide with setup operations performed by the driver.  The best way to
    avoid the contention is to have the driver delay an additional 10
    milliseconds.  B0 revisions of the chip will make this workaround
    unnecessary.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f89f38b8ec3171664314669a1396ab70b43e8961
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:07 2010 +0000

    tg3: Unwedge stuck MSI-X vectors
    
    The previous patch changed the code so that new rx buffer submissions to
    the hardware stall if a new submission would overwrite data needed by an
    unserviced rx packet.  On very busy 5717 and 57765 asic rev devices,
    there is a corner case where the hardware will fail to assert an MSI-X
    interrupt for rx traffic.  If that vector's interrupt never has another
    reason to assert, any rx buffers held will never be serviced.  If the
    buffers are never serviced and the hardware consumes all the available
    rx packets for other rx rings, deadlock will result.
    
    The most reliable and least intrusive way to work around the problem is
    to detect the case where new submissions would overwrite existing data
    and force all rx interrupt vectors to fire.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e92967bfb1f4fa7da7c425df9239c4bb615dec30
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:06 2010 +0000

    tg3: Prevent rx producer ring overruns
    
    When operating in RSS mode, it is possible for one rx return ring to
    submit enough rx buffers back to the hardware such that it inadvertently
    overwrites data needed by another rx return ring.  This patch addresses
    the problem by looking for non-NULL skb pointers in the
    rx_[std|jmb]_buffers rings that parallel the rx producer rings.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e4af1af900328e4aa71cd5df75bb22669ab11522
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Feb 12 14:47:05 2010 +0000

    tg3: Give MSI-X vec 1 rx backlog space
    
    RSS ring 1 is responsible for submitting new rx buffers to the
    hardware on behalf of all the other RSS rx return rings.  Up until now
    this ring submitted its new rx buffers to the producer ring directly.
    The following patch will require that this ring have a place to put
    backlogged rx packets.  As a consequence, it can no longer submit new
    buffers to the producer ring.
    
    This patch adds code to allocate an extra shadow producer ring for this
    RSS ring and adds RSS ring 1 to the list of rings needing buffer
    transfers.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4cd24eaf0c6ee7f0242e34ee77ec899f255e66b5
Author: Jiri Pirko <jpirko@redhat.com>
Date:   Mon Feb 8 04:30:35 2010 +0000

    net: use netdev_mc_count and netdev_mc_empty when appropriate
    
    This patch replaces dev->mc_count in all drivers (hopefully I didn't miss
    anything). Used spatch and did small tweaks and conding style changes when
    it was suitable.
    
    Jirka
    
    Signed-off-by: Jiri Pirko <jpirko@redhat.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 51c24aaacaea90c8e87f1dec75a2ac7622b593f8
Merge: 4276e47 6be3257
Author: David S. Miller <davem@davemloft.net>
Date:   Sat Jan 23 00:31:06 2010 -0800

    Merge branch 'master' of master.kernel.org:/pub/scm/linux/kernel/git/davem/net-2.6

commit b0f752210c0aa5e3d9ece4cbfefdc43092a68b83
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:11 2010 +0000

    tg3: Add 57765 phy ID and enable devices.
    
    This patch rounds out the 57765 asic rev support by adding the 57765 phy
    ID and entering the 57765 device IDs in the pci table.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 334355aa590c4b58750015c2f5710cd5074f45dd
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:10 2010 +0000

    tg3: Bypass power source switching for 57765
    
    The 57765 repurposes all the GPIOs normally used to switch power sources
    when configured as a NIC device.  This patch changes the code to avoid
    touching the GPIOs for this asic rev.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cb4ed1fd8af963101a59c8c5fef97cbbf5f3fb88
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:09 2010 +0000

    tg3: Turn off the debug UART for 57765
    
    If the debug UART is left enabled, the LEDs will not work properly.
    This patch disables the debug UART.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c2353a3214ff5813c4b719b3cdacbe939b1c63a0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:08 2010 +0000

    tg3: Fix tx mailbox initialization
    
    If a device supports MSI-X interrupts, the driver assumes TSS will be
    available.  This is not true for the 57765.  This patch changes the code
    so that only the default tx mailbox is initialized if TSS is not
    available.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5fd68fbdaf75505a2400826c7f314a1f3121a5f7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:07 2010 +0000

    tg3: Supply a nicaddr for 57765 jumbo RCB
    
    The 57765 needs the driver to supply a nic address to the jumbo RCB,
    just like all other devices except the 5717.  This patch changes the
    test to single out the 5717 rather than maintain a lengthy whitelist of
    asic revs.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8b5a6c42e1f2277433aeefa9ee5a0c1a2473b7d8
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:06 2010 +0000

    tg3: Fix 5717 and 57765 memory selftests
    
    Both the 5717 and the 57765 will fail 'ethtool -t' selftests at the
    memory selftest portion.  The memory map for these two devices differs
    from the rest of the asic revs and each other.  This patch adds a new
    memory map to use for memory selftests.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ecf1410b9d70b3034e5955e92bb0c3e02ff21e9c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:05 2010 +0000

    tg3: Abort phy init for 5717 serdes devices
    
    The 5717 serdes devices have a different phy register layout than all
    other previous serdes devices.  This patch aborts the phy init sequence
    in tg3_phy_reset() if the device is a 5717 serdes.  It also aborts the
    tg3_phy_toggle_apd() operation.  Most other operations in the MII_SERDES
    path are O.K.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9b952f51d019db37276bdb2924e776ca09132fc1
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:04 2010 +0000

    tg3: Add 5717 serdes phy ID
    
    The serdes and copper phys of the 5717 asic rev have different phy IDs.
    This patch adds the serdes phy ID.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 666bc831cf820e16cbd0c2d5be780c512b1afe15
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:03 2010 +0000

    tg3: Improve internal resource allocations
    
    The 5717 and the 57765 have more resources at their disposal internally.
    This patch tunes the driver to get better performance.  The adjustments
    made here only apply to the 57765 and 5717 asic revs.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 614b05900ec3516b835cd06f848ef6bc915beeea
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Jan 20 16:58:02 2010 +0000

    tg3: Enable PLL PD when CLKREQ disabled for 5717A0
    
    PCIe PLL power down cannot be used if CLKREQ is enabled because data
    corruption will occur.  If CLKREQ is disabled though, enabling PCIE P1
    PLL power-down saves some power.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ba5b0bfa06b6fbee03c6889046e9adcefa5d2c20
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 12 10:11:40 2010 +0000

    tg3: Update copyright and driver version
    
    This patch updates the copyright notice for 2010 and updates the version
    number to 3.106.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 55dffe79b34e2af98bd1315f1e00c2fc6a7a7078
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 12 10:11:39 2010 +0000

    tg3: Disable 5717 serdes and B0 support
    
    The B0 revision of the 5717 will not get enough testing by the time
    2.6.33 ships.  Since the kernel is already at RC3, serdes support
    will require too many patches to fix.  For these reasons, this patch
    disables 5717 serdes support and will refuse to attach to all 5717
    devices that are later than an A0 revision.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d1ec96af77df611d1728f3bb70289f83a02df1ea
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 12 10:11:38 2010 +0000

    tg3: Add reliable serdes detection for 5717 A0
    
    The serdes status bit does not work as intended for the 5717 A0.
    This patch implements an alternative detection scheme that will only be
    valid for A0 revisions.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 86cfe4ff02a51294cb2c974a8bedc7f648491df9
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 12 10:11:37 2010 +0000

    tg3: Fix std rx prod ring handling
    
    There are some tg3 devices that require the driver to post new rx
    buffers in smaller increments.  Commit
    4361935afe3abc3e5a93006b99197fac1fabbd50, "tg3: Consider
    rx_std_prod_idx a hw mailbox" changed how the driver tracks the rx
    producer ring updates, but it does not make any special considerations
    for the above-mentioned devices.  For those devices, it is possible for
    the driver to hit the special case path, which updates the hardware
    mailbox register but skips updating the shadow software mailbox member.
    If the special case path represents the final mailbox update for this
    ISR iteration, the hardware and software mailbox values will be out of
    sync.  Ultimately, this will cause the driver to use a stale mailbox
    value on the next iteration, which will appear to the hardware as a
    large rx buffer update.  Bad things ensue.
    
    The fix is to update the software shadow mailbox member when the special
    case path is taken.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reported-by: Dmitry Torokhov <dmitry.torokhov@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 13fa95b0398d65885a79c6e95a09976ee9f8c009
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Jan 12 10:11:36 2010 +0000

    tg3: Fix std prod ring nicaddr for 5787 and 57765
    
    Commit 87668d352aa8d135bd695a050f18bbfc7b50b506, titled "tg3: Don't
    touch RCB nic addresses", tried to avoid assigning the nic address of
    the standard producer ring.  Unfortunately, the default nic address is
    not correct for the 5787, the 5755M, or the 57765.  This patch
    reenables the old behavior and opts out of the assignment only
    for the 5717.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Tested-by: Chow Loong Jin <hyperair@ubuntu.com>
    Tested-by: Dmitry Torokhov <dtor@mail.ru>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a3aa18842a5303fc28fcc4d57dbd16618bd830a0
Author: Alexey Dobriyan <adobriyan@gmail.com>
Date:   Thu Jan 7 11:58:11 2010 +0000

    drivers/net/: use DEFINE_PCI_DEVICE_TABLE()
    
    Use DEFINE_PCI_DEVICE_TABLE() so we get place PCI ids table into correct section
    in every case.
    
    Signed-off-by: Alexey Dobriyan <adobriyan@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cceea982ef78cf358b70f3412a6799f153211e14
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Dec 3 08:36:25 2009 +0000

    tg3: Update version to 3.105
    
    This patch updates the tg3 version to 3.105.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 026a6c21646cf77ea838f3c121de29cdf948ca71
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Dec 3 08:36:24 2009 +0000

    tg3: Clean tg3_init_one()
    
    Tg3's firmware is no longer loaded from tg3_init_one().  Remove the
    error path that releases the firmware back to the system.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 94c982bd9f07b801f03cebe32b20f893b4ad6d27
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Dec 3 08:36:23 2009 +0000

    tg3: Use pci_read_vpd() instead of private method
    
    If the driver needs to use PCI configuration space to read the VPD data,
    the accesses could collide with the pci_read_vpd() function.  This patch
    converts the driver to use pci_read_vpd() to avoid any potential
    collisions.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 141518c95870228da4e050fbe31a8f0c9df82c72
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Dec 3 08:36:22 2009 +0000

    tg3: Add some VPD preprocessor constants
    
    This patch cleans up the VPD code by creating preprocessor definitions
    and using them in the place of hardcoded constants.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b703df6f628ab63eaa875232551b1f2f0503b9af
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Dec 3 08:36:21 2009 +0000

    tg3: Add 57765 asic rev
    
    This patch adds the 57765 asic revision.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 19cfaecc094781da273b5cd1411ee46589898d0e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Thu Dec 3 08:36:20 2009 +0000

    tg3: Make TSS enable independent of MSI-X enable
    
    The 57765 asic rev has MSI-X capability, but does not support TSS.  This
    patch changes the tx paths so that TSS is explicitly mentioned, rather
    than implied through the ENABLE_MSIX flag.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8e95a2026f3b43f7c3d676adaccd2de9532e8dcc
Author: Joe Perches <joe@perches.com>
Date:   Thu Dec 3 07:58:21 2009 +0000

    drivers/net: Move && and || to end of previous line
    
    Only files where David Miller is the primary git-signer.
    wireless, wimax, ixgbe, etc are not modified.
    
    Compile tested x86 allyesconfig only
    Not all files compiled (not x86 compatible)
    
    Added a few > 80 column lines, which I ignored.
    Existing checkpatch complaints ignored.
    
    Signed-off-by: Joe Perches <joe@perches.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f4188d8affc8267a0f0f1b587a4d0a4b9b7f2999
Author: Alexander Duyck <alexander.h.duyck@intel.com>
Date:   Wed Dec 2 16:48:38 2009 +0000

    tg3: remove use of skb_dma_map/unmap
    
    Due to the fact that skb_dma_map/unmap do not work correctly when a HW
    IOMMU is enabled it has been recommended to go about removing the calls
    from the network device drivers.
    
    Signed-off-by: Alexander Duyck <alexander.h.duyck@intel.com>
    Signed-off-by: Jeff Kirsher <jeffrey.t.kirsher@intel.com>
    CC: Matt Carlson <mcarlson@broadcom.com>
    CC: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c5d5d1721763842a516529e553433d13b11c3f31
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:52 2009 +0000

    tg3: Update version to 3.104
    
    This patch updates the tg3 version to 3.104.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5001e2f638011859c1351f9fe57ca4e545a15c47
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:51 2009 +0000

    tg3: Fix DIDs, Enable 5717 support
    
    This patch fixes the 5717 variant device ID enumerations and adds those
    DIDs to the PCI ID table.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b196c7e45f30cbcd38c83386bc8a04a21477f8d3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:50 2009 +0000

    tg3: Add rx prod ring consolidation
    
    This patch adds code to funnel each MSI-X vector's rx packet buffers
    into a single set of producer rings which will then be submitted to the
    hardware.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 66711e66639776685aeaad774488be1857abce26
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:49 2009 +0000

    tg3: Create aliases for rx producer mailbox regs
    
    The rx producer mailbox registers are used in several spots in the code.
    The addition of TG3_64BIT_REG_LOW makes register references
    uncomfortably long.  This patch creates an alias for the standard and
    jumbo ring producer index registers to make the code cleaner.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2b2cdb65bec42d38268b2ac115876b066afa7f95
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:48 2009 +0000

    tg3: Lay proucer ring handling groundwork
    
    The patch increases the number of producer rings available and
    implements the constructor and destructor code that deals with them.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4361935afe3abc3e5a93006b99197fac1fabbd50
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:47 2009 +0000

    tg3: Consider rx_std_prod_idx a hw mailbox
    
    This patch changes how the code uses the rx_std_prod_idx member.  In the
    following patch, the code will be changed so that it will act just like
    a hardware mailbox.  This patch prepares the code so that memory barriers
    can be more easily inserted.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 411da6407e778bf946911df08bb5afc505422f31
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:46 2009 +0000

    tg3: rename rx_[std|jmb]_ptr
    
    A later patch is going to add consumer indicies for the producer rings.
    To keep things readable, this patch renames rx_[std|jmb]_ptr to
    rx_[std|jmb]_prod_idx.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 86b21e59c9a65c8e46d35ac6c4220f63639828c6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:45 2009 +0000

    tg3: tg3_alloc_rx_skb(tnapi => tp)
    
    This patch converts the tnapi argument of tg3_alloc_rx_skb() to tp.  The
    level of indirection is unnecessary.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a3896167160ce9ad1eadeb88fd2f3971888444ae
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:44 2009 +0000

    tg3: Add prodring parameter to tg3_alloc_rx_skb()
    
    This patch changes the tg3_alloc_rx_skb() implementation to accept the
    destination producer ring set pointer as a parameter rather than
    assuming the source and destination producer rings are the same.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit afc081f83c59a7cf2c025a3ed89d011b5db556eb
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:43 2009 +0000

    tg3: Make tg3_alloc_rx_skb() a dst-only operation
    
    This patch removes the source index parameter of tg3_alloc_rx_skb().  A
    later patch will make it possible for the source and destination
    producer rings to be different.  This patch opts to make
    tg3_alloc_rx_skb() a destination-only implementation and move the code
    sensitive to the difference elsewhere.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 78f90dcf184b8225a24217605c4289f1986451a3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:42 2009 +0000

    tg3: Move napi_add calls below tg3_get_invariants
    
    tg3_get_invariants(), among other things, discovers whether or not
    the device is MSI-X capable and how many interrupts it supports.
    This discovery needs to happen before registering NAPI instances with
    netdev.  This patch moves the code block that calls napi_add later in
    tg3_init_one() so that tg3_get_invariants() has a chance to run first.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 35f2d7d0d7c222a580da0ed91c8d70c54267620a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:41 2009 +0000

    tg3: Create tg3_poll_msix() for non-zero MSIX vecs
    
    This patch gives all non-zero MSIX vectors their own NAPI handler.  This
    will make NAPI handling for those vectors slightly more efficient.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cbf9ca6cf8304beb640a948709c4672bc1d5a55f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:40 2009 +0000

    tg3: Allow DMAs to cross cacheline boundaries
    
    By default, the 5717 (and future chips) break up PCIe DMA packets across
    cacheline boundaries.  This isn't necessary on x86.  This patch
    selectively loosens the restriction.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 615774fe598f8ee971a8dfeb1f2ec4211241c433
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:39 2009 +0000

    tg3: Use tg3_start_xmit_dma_bug for 5717 A0
    
    The A0 revision of the 5717 has problems with short packet fragments.
    It needs to use the tg3_start_xmit_dma_bug() routine.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e849cdc309de4a1e49dc3c23c6c36da91b990c9f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:38 2009 +0000

    tg3: Add new HW_TSO_3 flag for 5717
    
    The 5717 sets up TSO slightly differently in the transmit path.  It
    looks like this method will be the new way of doing things.  This patch
    defines a flag to indicate this.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 507399f18ea5810de42f0ea228c14305a8f67512
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:37 2009 +0000

    tg3: Refine TSO and MSI discovery
    
    This patch consolidates the TSO capability discovery code into its own
    code block.  The code that decides whether or not to allow TSO is then
    cleaned up.  Finally, the patch consolidates all MSI and MSIX
    capability code into a single code block.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f66a29b03a2637ff052f2b8a81a5417fa44e228b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:36 2009 +0000

    tg3: Move TG3_FLG2_PROTECTED_NVRAM to tg3_flags3
    
    We need room for another TSO flag and it would be most efficient if it
    resided in tg3_flags2.  This patch moves the TG3_FLG2_PROTECTED_NVRAM
    to tg3_flags3 to make room.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 24f4efd4e6c89a4093d0b8653d6669e45de45001
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:35 2009 +0000

    tg3: Napify tg3_start_xmit_dma_bug()
    
    This patch converts tg3_start_xmit_dma_bug() to accomodate multiple NAPI
    instances.  This is prep work for a later patch in this series.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 87668d352aa8d135bd695a050f18bbfc7b50b506
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:34 2009 +0000

    tg3: Don't touch RCB nic addresses
    
    This patch avoids reprogramming the RCB NIC addresses for all 5755 and
    later devices.  The address is incorrect for 5717 devices and should be
    correct by default for all other affected devices.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c2060fe1f36565e60e622662a4519babd3b72f68
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 13 13:03:33 2009 +0000

    tg3: Add 5717 phy ID
    
    This patch adds the 5717 phy ID.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 123b43e9716115302a0095e14f2c545811712715
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:33:03 2009 +0000

    tg3: Update version to 3.103
    
    This patch updates the tg3 version to 3.103.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 52fae0837153e86e4dabaf5df517a0b8b7a20bd7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:32:38 2009 +0000

    tg3 / broadcom: Optionally disable TXC if no link
    
    This patch adds code to disable the TXC and RXC reference clocks if link
    is not available.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c704dc23cac0e433796bfe0a1fe2f1a64da11ac7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:32:12 2009 +0000

    tg3 / broadcom: Add APD support for GPHYs
    
    This patch adds an RXC auto power-down feature to the code that supports
    the gphys.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 32e5a8d651c0dbb02bf82ca954206282e44c4b11
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:31:39 2009 +0000

    tg3 / broadcom: Add code to disable rxc refclk
    
    The 5785 does not use the RXC reference clock.  Turning it off is
    desirable as it saves power.
    
    By default, the 50610 enables the RXC reference clock and the 50610M
    disables it.  Presumably this is one of the reasons why the hardware
    architect chose one over the other.
    
    Adding a "rx reference clock disable" flag is not the ideal way to
    describe the option, as it would force the MAC using a 50610M to set
    the flag.  Ideally we want the flags to represent opt-in behavior that
    deviates from hardware defaults.  Furthermore, the lack of a
    "disable" flag implies that the requester wants the rx reference clock
    enabled, which doesn't necessarily follow.
    
    By presenting the option as a passive statement (rx reference clock
    unused) rather than a command, I hope to convey an opt-in option to
    disable the rx reference clock that falls back to hardware defaults if
    not set.  A secondary benefit of this is that it keeps the
    intelligence about phy defaults in the broadcom module where it belongs
    and allows the broadcom module more latitude should a bug arise.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cdd4e09d692bd4f3457b3789279005e112b7696d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:31:11 2009 +0000

    tg3 / broadcom: Refine AC131 APD support
    
    Auto power-down (APD) support is a power-saving feature.  It should be
    selectively enabled since it might expose MAC bugs.  This patch changes
    the code to enable APD only if the PHY_BRCM_AUTO_PWRDWN_ENABLE flag is
    set.  The tg3 driver was changed to set this bit.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 63a14ce449dd6d647de2725809159eb072b2c44f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:30:40 2009 +0000

    tg3 / broadcom: Add PHY_BRCM_CLEAR_RGMII_MODE flag
    
    Broadcom 50610M parts changed the default definitions of the RGMII mode
    shadow register.  The 5785 needs the RGMII mode selection bits [4:3]
    cleared.
    
    The default value of the remaining bits in this register are zero.
    Rather than unnecessarily burn an extra bit in the dev_flags member in
    an attempt to enumerate all possible combinations, this patch take a
    more course grained approach and labels the option as "clear all bits".
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c73430d04ec75962e20e186d34c40b6d999f0968
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:29:34 2009 +0000

    tg3: Add 50610M phy ID for 5785
    
    This patch adds the 50610M phy ID for 5785.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 303fc9218246a748304c005e629d658927cf12d0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:27:34 2009 +0000

    tg3: Extend loopback test timeout
    
    This patch extends the loopback test timeout from 250 usec to 350 usec.
    When the 5785 is paired against an AC131 phy, the older timeout is
    just a little too close to the expected performance based on timings.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c3df0748ee43101dfc5c94d1f61ddfca0ff5baa4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:27:02 2009 +0000

    tg3: 5785: Set port mode to MII when link down
    
    This patch sets the port mode to MII when the link is down for the 5785.
    Setting the port mode to MII instead of GMII saves power.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0e5f784c77197edf29d2770b518dc78777d5a480
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:26:38 2009 +0000

    tg3: Add AC131 power down support
    
    The AC131 does not respect the power down bit (bit 11) of the MII
    Control Register (reg 0x0).  Instead, software is required to put the
    phy into standby power down mode through the shadow register set.  This
    patch implements support for the AC131 standby power down mode.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 788a035e6061a66c6c77059c417fdc6234e140ff
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:26:03 2009 +0000

    tg3: Improve 5785 PCIe performance
    
    This patch improves 5785 performance by allowing the write DMA engine to
    request larger DMA burst sizes than it otherwise would.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a21771dd189b340328c573da9e005068e8a74c53
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:25:31 2009 +0000

    tg3: Add more PCI DMA map error checking
    
    This patch adds code to check the status of pci_map_single() before
    allowing rx buffers to be used.  It also converts the pci_map_single()
    call in tg3_run_loopback() to use skb_dma_map() instead.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 52cdf8526fe24f11d300b75458ddee017f3f4c88
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:25:06 2009 +0000

    tg3: Prevent a PCIe tx glitch
    
    This patch prevents a PCIe tx glitch by allowing the transmitter to go
    to a low power state.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3f0e3ad72393db9c2932a2ca86cc1a49294bbc63
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:24:36 2009 +0000

    tg3: Convert PHY_ADDR => TG3_PHY_MII_ADDR
    
    This patch renames the PHY_ADDR preprocessor definition.  The following
    patch will identify a new member on the MDIO bus, so we want this
    preprocessor definition to be a little more descriptive.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f40386c8452f9eead9c5906bfffaaf59f3dc748f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:24:02 2009 +0000

    tg3: Fix disappearing 57780 devices
    
    Under certain power saving conditions, 57780 asic rev devices might
    disappear from the system.  The fix is to disallow the PCIe PLL from
    powering down.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 92c6b8d16a36df3f28b2537bed2a56491fb08f11
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 14:23:27 2009 +0000

    tg3: Fix 5906 transmit hangs
    
    The 5906 has trouble with fragments that are less than 8 bytes in size.
    This patch works around the problem by pivoting the 5906's transmit
    routine to tg3_start_xmit_dma_bug() and introducing a new SHORT_DMA_BUG
    flag that enables code to detect and react to the problematic condition.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0e1406dd404ce55dbe8d68b4b5e2aed7e5c75fdb
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 2 12:33:33 2009 +0000

    tg3: Assign flags to fixes in start_xmit_dma_bug
    
    This patch adds a flag for each bug workaround in
    tg3_start_xmit_dma_bug().  This is prep work for the following patch.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 24bb4fb6dac59f220f42fb375ba0e0f19365a227
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Oct 5 17:55:29 2009 +0000

    tg3: Fix phylib locking strategy
    
    Felix Radensky noted that chip resets were generating stack trace dumps.
    This is because the driver is attempting to acquire the mdio bus mutex
    while holding the tp->lock spinlock.  The fix is to change the code such
    that every phy access takes the tp->lock spinlock instead.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5ea1c50662d447de344812054175d7151783ea25
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Sep 11 16:50:16 2009 -0700

    tg3: Fix return ring size breakage
    
    Commit f6eb9b1fc1411d22c073f5264e5630a541d0f7df, "tg3: Add 5717 asic
    rev" changed how the rx return ring size operations are done.  It
    effectively inverts the sense of the previous test, but it failed to
    also invert the resulting sizes.  This patch corrects that error.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7ab0f2736bfe137a82a7084bbfb5f809da95cabd
Author: Ben Hutchings <bhutchings@solarflare.com>
Date:   Thu Sep 3 10:39:43 2009 +0000

    netdev: Remove redundant checks for CAP_NET_ADMIN in MDIO implementations
    
    dev_ioctl() already checks capable(CAP_NET_ADMIN) before calling the
    driver's implementation of MDIO ioctls.
    
    Signed-off-by: Ben Hutchings <bhutchings@solarflare.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit daf09de817353f18bb81a23a023d429cfd258e62
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:22:42 2009 +0000

    tg3: Update version to 3.102
    
    This patch updates the tg3 version to 3.102.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 882e9793faa9425dff581c33b1af45ed10145626
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:21:36 2009 +0000

    tg3: Add MDIO bus address assignments
    
    The 5717 is a dual port chip that has a shared MDIO bus design.  While
    it is impossible for one function to interface with the wrong phy, that
    function still needs to know which MDIO bus address to use when
    interfacing with its own phy.  This patch adds code to determine which
    MDIO bus address to use.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a1b950d56de3c72bea3343f54de24c43fb7dc74e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:20:17 2009 +0000

    tg3: Add 5717 NVRAM detection routines
    
    This patch adds NVRAM detection routines for the 5717.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f6eb9b1fc1411d22c073f5264e5630a541d0f7df
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:19:53 2009 +0000

    tg3: Add 5717 asic rev
    
    This patch adds the 5717 asic rev.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8d9d7cfc0ec2fe37ff9afd74326d03f38f96ad1b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:19:05 2009 +0000

    tg3: Assign rx ret producer indexes by vector
    
    When RSS is enabled, the status block format changes slightly.  The
    "rx_jumbo_consumer", "reserved", and "rx_mini_consumer" members get
    mapped to the other three rx return ring producer indexes.  This patch
    introduces a new per-interrupt member which identifies which location
    in the status block a particular vector should look for return ring
    updates.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0c1d0e2b05e92ad847b3ebe1c75b7974086bc8fa
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:16:33 2009 +0000

    tg3: Adjust RSS ring allocation strategies
    
    When multivector RSS is enabled, the first interrupt vector is only used
    to report link interrupts and error conditions.  This patch changes the
    code so that rx and tx ring resources are not allocated for this vector.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit baf8a94a572928710e9e60967d153a7bf3aebd9c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:13:00 2009 +0000

    tg3: Add RSS support
    
    This patch adds code needed to enable RSS.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b6080e126012047d42e53154189fdca286d0600e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:12:00 2009 +0000

    tg3: Add coalesce parameters for msix vectors
    
    This patch adds code to tune the coalescing parameters for the other
    msix vectors.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fed9781081aa9600765346c108ff22751e003715
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:10:19 2009 +0000

    tg3: Enable NAPI instances for other int vectors
    
    This patch adds code to enable and disable the rest of the NAPI
    instances.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fe5f5787f0866e9f883bdd90018a354f2f3defd1
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:09:39 2009 +0000

    tg3: Add TSS support
    
    This patch exposes the additional transmit rings to the kernel and makes
    the necessary modifications to transmit, open, and close paths.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 89aeb3bceaa1a02651206a76a7b9dcb8f3884702
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:08:58 2009 +0000

    tg3: Update intmbox and coal_now for msix
    
    This patch fixes up two spots that need attention now that msix support
    has been added.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f77a6a8e6cee17b21a43bdf6b853cc2fc0e2c4df
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 13:04:37 2009 +0000

    tg3: Add tx and rx ring resource tracking
    
    This patch adds code to assign status block, tx producer ring and rx
    return ring resources needed for the other interrupt vectors.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 646c9eddcffd202bb0f3d906cecf94eaf10cad31
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 12:58:41 2009 +0000

    tg3: Add mailbox assignments
    
    The 5717 assigns mailbox locations to interrupt vectors in a rather
    non-intuitive way.  (Much of the complexity stems from legacy
    compatibility issues.)  This patch implements the assignment scheme.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 679563f47cd2547a0e091b5bd3ddf30027af6b08
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 12:55:46 2009 +0000

    tg3: Add MSI-X support
    
    This patch adds MSI-X support.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4f125f42dd55390016e21f8b3960f99d02d1001f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 12:55:02 2009 +0000

    tg3: Add support code around kernel interrupt API
    
    This patch adds code to support multiple interrupt vectors around the
    kernel's interrupt API.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2d31ecaf10c4ae03d49aed516481b2839b0220f6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 12:53:31 2009 +0000

    tg3: Create tg3_rings_reset()
    
    This patch moves most of the chip ring setup logic into a separate
    function.  This will make it easier to verify the multi ring setup
    changes.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fd2ce37f8e4a570ce90b141a2e7c476c5b399836
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 12:51:13 2009 +0000

    tg3: Add per-int coalesce now member
    
    Each interrupt vector has its own bit in the host coalescing register to
    force that vector's status block to be updated and generate an
    interrupt.  This patch adds a member to the per-interrupt structure
    that records which bit belongs to that vector.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f19af9c2cc015e42dfe4bd5c383e32066ec2801c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Sep 1 12:47:49 2009 +0000

    tg3: inline tg3_cond_int()
    
    This patch inlines the code of tg3_cond_int() into the function's only
    callsite.  This prep work makes the following patch cleaner.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 61357325f377889a1daffa14962d705dc814dd0e
Author: Stephen Hemminger <shemminger@vyatta.com>
Date:   Mon Aug 31 19:50:58 2009 +0000

    netdev: convert bulk of drivers to netdev_tx_t
    
    In a couple of cases collapse some extra code like:
       int retval = NETDEV_TX_OK;
       ...
       return retval;
    into
       return NETDEV_TX_OK;
    
    Signed-off-by: Stephen Hemminger <shemminger@vyatta.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fc57e515a2c02599b00d252545521288dfc0158a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:03:44 2009 +0000

    tg3: Update version to 3.101
    
    This patch updates the tg3 version to 3.101.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f3f3f27e5b4e27737f824535e6f145a3c88b976c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:03:21 2009 +0000

    tg3: Move per-int tx members to a per-int struct
    
    This patch moves the tx_prod, tx_cons, tx_pending, tx_ring, and
    tx_buffers transmit ring device members to a per-interrupt structure.
    It also adds a new transmit producer mailbox member (prodmbox) and
    converts the code to use it rather than a preprocessor constant.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 723344820aa405ac2663ab9e36fd27833d06129b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:03:01 2009 +0000

    tg3: Move per-int rx members to per-int struct
    
    This patch moves the rx_rcb, rx_rcb_mapping, and rx_rcb_ptr return ring
    device members to a per-interrupt structure.  It also adds a new return
    ring consumer mailbox register member (consmbox) and converts the code
    to use it rather than a preprocessor constant.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 898a56f8d8170c188e47ae3acb90d2ea9a585ebe
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:02:40 2009 +0000

    tg3: Move general int members to a per-int struct
    
    This patch moves the last_tag, last_tag_irq, and hw_status device
    members to a per-interrupt structure.  It also adds a new interrupt
    mailbox member (int_mbox) and converts the code to use it rather than a
    direct preprocessor constant.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 17375d25d3dcd3d4caf9456fa94f60e29d6b1146
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:02:18 2009 +0000

    tg3: Convert napi handlers to use tnapi
    
    This patch converts the napi interrupt handler functions to accept and
    use tg3_napi structures.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 09943a1819a240ff4a72f924d0038818fcdd0a90
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:01:57 2009 +0000

    tg3: Convert ISR parameter to tnapi
    
    This patch migrates the ISR parameter from struct net_device to struct
    tg3_napi.  Checkpatch complains about the existence of the preexisting
    IRQF_SAMPLE_RANDOM flag.  I've opted to keep this patch conservative and
    let it continue to exist until the flag gets officially purged from the
    kernel.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8ef0442f98850333196bc56415192e52a6267878
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:01:37 2009 +0000

    tg3: Move napi to per-int struct
    
    This patch creates a per-interrupt data structure, moves the napi
    member over, and creates a tg3 pointer back to the device structure.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 07b0173cb5d6a9d77646cd855066ebe90b9203f2
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:01:15 2009 +0000

    tg3: Cleanup interrupt setup / teardown
    
    Later patches will be adding MSIX support, which will complicate
    interrupt initialization.  This patch prepares for the integration by
    breaking out the interrupt setup and teardown code into separate
    functions and cleaning up the error return paths.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 79ed5ac7ddd5f8d6463f5a17b3575772e9896481
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:00:55 2009 +0000

    tg3: Use ext rx bds
    
    The 5717 only uses extended buffer descriptors for the jumbo producer
    ring.  Extended buffer descriptors are available on all devices that
    support a separate jumbo producer ring so make the change universal.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 21f581a5366d48d86b9ae86043fc61d44e992c0c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 14:00:25 2009 +0000

    tg3: Create a new prodring_set structure
    
    This patch migrates most of the rx producer ring variables to a new
    tg3_rx_prodring_set structure and modifies the code accordingly.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cf7a7298c4f47ab7546b933bb54ad3ea03a1daf6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 13:59:57 2009 +0000

    tg3: Create rx producer ring setup routines
    
    Later patches are going to complicate the ring initialization routines.
    This patch breaks out the setup and teardown of the rx producer rings
    into separate functions to make the code more readable.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 287be12e1774d842bff21ea0c1809c2387d7b310
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 13:58:46 2009 +0000

    tg3: Clarify rx buffer relationships
    
    This patch attempts to document the various rx buffer sizes used by the
    driver and how they relate to each other.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8f666b07ac53eeedd6c035adf6d4299f9ed0df2d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 13:58:24 2009 +0000

    tg3: Move the JUMBO_CAPABLE and SUPPORT_MSI flags
    
    This patch moves where the jumbo capable and msi support flags are
    located.  This is prep work for the addition of msix support flags.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fdb72b38c94c0ead1f78ecc8db64b832feda22c3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 13:57:12 2009 +0000

    tg3: Break out mini producer ring handling
    
    This patch separates the code that sets up the mini producer ring from
    the code that sets up the jumbo producer rings.  The 5717 asic rev
    devices do not have a mini ring, but do have a jumbo frame
    implementation similar to the 5704 and previous devices.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8590a603e5e20ccf49d6cf0ea71ecf5388d1f9da
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 12:29:16 2009 +0000

    tg3: Reformat NVRAM case statements
    
    This patch fixes up the NVRAM detection switch statements to conform
    to the kernel coding style.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2befdcea96fcd9a13e94373c66ea1dd7365d2a74
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 12:28:45 2009 +0000

    tg3: Add new 5785 10/100 only device ID
    
    This patch adds a new device ID for those 5785 devices that will only
    use 10/100 phys.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0a9140cff22e405fce1747a2e02d41851c36c55a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 28 12:27:50 2009 +0000

    tg3: Delay mdio bus init until fw finishes
    
    The device firmware uses the MDIO bus during early setup.  If the driver
    modifies the MDIO bus configuration while it is in use by the firmware,
    any number of bad things can happen.  This patch delays MDIO setup until
    after the firmware posts its magic signature, signifying initialization
    is complete.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f656f39801b00c3c2aa26cefbdee2775d6706d45
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:11:55 2009 +0000

    tg3: Update version to 3.100
    
    This patch updates the tg3 version to 3.100.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7f97a4bd47291e4ec9b9eaf63d7275ddfb498cb3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:10:03 2009 +0000

    tg3: Convert code to use PHY_IS_FET
    
    This patch converts the code to use the PHY_IS_FET flag rather than the
    ASIC revision to decide whether or not to use FET paths.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 535ef6e1124d445efbcc13b7126561dc544b0b64
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:09:36 2009 +0000

    tg3: Create MII_TG3_FET namespace
    
    Broadcom's phys come in two distinctly different register layouts.  For
    the lack of an official term to distinguish between the two formats, we
    can loosely categorize them by their fast ethernet or gigabit ethernet
    transceiver description.  This patch creates the (driver-internal) Fast
    Ethernet Transceiver (FET) namespace and converts the 5906 EPHY
    definitions over.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bb85fbb6a98d8edab81599913559c7ff0a963984
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:09:07 2009 +0000

    tg3: Tune 5785 clock switching
    
    This patch tunes the timeouts the CPMU uses to decide when to switch
    from the clocks output by the PHY to internal clock sources.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5e7ccf2003e6a9c35b5aa24953ba5009a1a8b653
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:08:42 2009 +0000

    tg3: Add 57788, remove 57720
    
    This patch adds support for the 57788 and removes support for the 57720
    which was never released.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e7126997342560533317d8467e8516119ebcbd21
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:08:16 2009 +0000

    tg3: Preserve PCIe MPS setting for new devs
    
    Most older tg3 devices only supported a PCIe maximum payload size of
    128 bytes.  More recent devices bump this limit up to 256 bytes
    though.  This patch modifies the code so that the MPS limit is only
    enforced on those devices that only allow the 128 byte setting.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 29ea095fb727ac48228ff2d1af484c27bf1dcbd4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:07:54 2009 +0000

    tg3: Fix TSO test against wrong flags var
    
    Julia Lawall discovered that the TG3_FLG2_TSO_CAPABLE flag was being
    compared against the wrong flags device member.  This patch implements
    the fix.
    
    Signed-off-by: Julia Lawall <julia@diku.dk>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 255ca311b650caece3ec4f78b88ef298664d561f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:07:27 2009 +0000

    tg3: Prevent tx BD corruption
    
    This patch prevents a tx BD corruption bug by preventing the device from
    powering down the PLL from L1 if the link speed is 10Mbps or 100Mbps.
    
    The same bits are also used to prevent a system hang during chip reset
    resulting from a complicated set of events that ultimately leads to
    PCIe block register corruption.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 521e6b90dd3f0392062845d7ef13e6e41bb99d8a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Tue Aug 25 10:06:01 2009 +0000

    tg3: Fix 57780 asic rev PCIe link receiver errors
    
    This patch fixes some PCIe link receiver errors by decreasing the internal
    electrical idle timeout.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Reviewed-by: Michael Chan <mchan@broadcom.com>
    Reviewed-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 042a53a9e437feaf2230dd2cadcecfae9c7bfe05
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Fri Jun 5 04:04:16 2009 +0000

    net: skb_shared_info optimization
    
    skb_dma_unmap() is quite expensive for small packets,
    because we use two different cache lines from skb_shared_info.
    
    One to access nr_frags, one to access dma_maps[0]
    
    Instead of dma_maps being an array of MAX_SKB_FRAGS + 1 elements,
    let dma_head alone in a new dma_head field, close to nr_frags,
    to reduce cache lines misses.
    
    Tested on my dev machine (bnx2 & tg3 adapters), nice speedup !
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit cdd0db058d64f2619b08e7d098ee0014aa0a5bc1
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Thu May 28 00:00:41 2009 +0000

    net: dont update dev->trans_start
    
    Second round of drivers for Gb cards (and NIU one I forgot in the 10GB round)
    
    Now that core network takes care of trans_start updates, dont do it
    in drivers themselves, if possible. Drivers can avoid one cache miss
    (on dev->trans_start) in their start_xmit() handler.
    
    Exceptions are NETIF_F_LLTX drivers
    
    Signed-off-by: Eric Dumazet <eric.dumazet@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bb9e63e27117b469a151c61fb0045a8ec4cced5d
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 20 07:13:31 2009 +0000

    tg3: Update version to 3.99
    
    This patch updates the tg3 version to 3.99.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit daba2a631d2b7831b6a021b36d61314a9153526e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 20 06:58:52 2009 +0000

    tg3: Restore LAA sooner in shutdown sequence
    
    After a shutdown reset, the LAA needs to be restored before posting the
    post-reset signature in shared memory.  If the LAA is not restored
    before then, the bootcode will assume the factory default MAC address
    and WOL will not work with the LAA.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9cf74ebb634fe79587cf9a1d5ff971391dd12e1b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 20 06:58:27 2009 +0000

    tg3: Limit CLKREQ fix to A[01] of 57780 asic rev
    
    This patch restricts the CLKREQ bugfix to the A0 and A1 revisions
    of 57780 ASIC rev chips.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 8d519ab2866c92f5d722085492a124f016f601aa
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 20 06:58:01 2009 +0000

    tg3: Allow 5761 WOL and LED fixes to 5761S too
    
    The 5761 WOL and LED fixes used the PCI device ID to as the activation
    key.  The 5761S requires the same process.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 33466d938f43ab65312466ba5472b9c6ee200cce
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 20 06:57:41 2009 +0000

    tg3: Prevent send BD corruption
    
    On rare occasions, send BD corruptions can occur.  This patch
    fixes the problem by increasing the L1 entry threshold to 4
    milliseconds.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit df259d8cba7d7880dc04d34c7a6e0ce15fbc9644
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 20 06:57:14 2009 +0000

    tg3: Handle NVRAM absent cases
    
    Some 57780 ASIC revision parts do not have NVRAM.  Code the driver so
    that it is tolerant of this configuration.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 624f8e5082efd0348ccf7e3d3f4bfc41efead26c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 20 06:55:01 2009 +0000

    tg3: Allow screaming interrupt detection
    
    The tg3 driver's ISR is coded to accept interrupts as its own if the
    status block tag does not equal the last tag the driver has seen.  The
    last_tag field is updated from tg3_poll.  In a screaming interrupt
    situation from another device sharing tg3's IRQ, tg3_poll does not get
    a chance to be called, so the last_tag will always be out of sync with
    the status block tag.  Consequently, the driver will continually
    declare the screaming interrupts as its own, thus thwarting the
    screaming interrupt detection logic.
    
    This patch solves the problem by creating a new last_irq_tag member and
    recording the status block tag in the ISR.  The ISR then checks the
    last_irq_tag for interrupt ownership.
    
    Many thanks to John Marvin for the detailed bug report and analysis and
    Michael Chan for the bugfix.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Tested-by: John Marvin <jsm@fc.hp.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 62cedd11f63c99efd2962fb69763a09e2778f6e6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Apr 20 14:52:29 2009 -0700

    tg3: Fix SEEPROM accesses
    
    The recent NVRAM patches sanitized how the driver deals with NVRAM
    data, but they failed to bring the SEEPROM interfaces inline with
    the new strategy.  This patch brings the SEEPROM interfaces up to date.
    This patch also reverts commit 0d489ffb76de0fe804cf06a9d4d11fa7342d74b9
    ("tg3: fix big endian MAC address collection failure").
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Tested-by: Robin Holt <holt@sgi.com>
    Tested-by: James Bottomley <james.bottomley@HansenPartnership.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0d489ffb76de0fe804cf06a9d4d11fa7342d74b9
Author: James Bottomley <James.Bottomley@HansenPartnership.com>
Date:   Mon Apr 13 14:31:51 2009 -0700

    tg3: fix big endian MAC address collection failure
    
    We noticed on parisc that our broadcoms all swapped MAC addresses going
    from 2.6.29 to 2.6.30-rc1:
    
    Apr 11 07:48:24 ion kernel: eth0: Tigon3 [partno(BCM95700A6) rev 0105] (PCI:66MHz:64-bit) MAC address 00:30:6e:4b:15:59
    Apr 13 07:34:34 ion kernel: eth0: Tigon3 [partno(BCM95700A6) rev 0105] (PCI:66MHz:64-bit) MAC address 00:00:59:15:4b:6e
    
    The problem patch is:
    
    commit 6d348f2c1e0bb1cf7a494b51fc921095ead3f6ae
    Author: Matt Carlson <mcarlson@broadcom.com>
    Date:   Wed Feb 25 14:25:52 2009 +0000
    
        tg3: Eliminate tg3_nvram_read_swab()
    
    With the root cause being the use of memcpy to set the mac address:
    
       memcpy(&dev->dev_addr[0], ((char *)&hi) + 2, 2);
       memcpy(&dev->dev_addr[2], (char *)&lo, sizeof(lo));
    
    This might work on little endian machines, but it can't on big endian
    ones.  You have to use the original setting mechanism to be correct on
    all architectures.
    
    The attached patch fixes parisc.
    
    Signed-off-by: James Bottomley <James.Bottomley@HansenPartnership.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 284901a90a9e0b812ca3f5f852cbbfb60d10249d
Author: Yang Hongyang <yanghy@cn.fujitsu.com>
Date:   Mon Apr 6 19:01:15 2009 -0700

    dma-mapping: replace all DMA_32BIT_MASK macro with DMA_BIT_MASK(32)
    
    Replace all DMA_32BIT_MASK macro with DMA_BIT_MASK(32)
    
    Signed-off-by: Yang Hongyang<yanghy@cn.fujitsu.com>
    Signed-off-by: Andrew Morton <akpm@linux-foundation.org>
    Signed-off-by: Linus Torvalds <torvalds@linux-foundation.org>

commit 50cf156af7dc68a44409bef636585ef88ebbab34
Author: Yang Hongyang <yanghy@cn.fujitsu.com>
Date:   Mon Apr 6 19:01:14 2009 -0700

    dma-mapping: replace all DMA_40BIT_MASK macro with DMA_BIT_MASK(40)
    
    Replace all DMA_40BIT_MASK macro with DMA_BIT_MASK(40)
    
    Signed-off-by: Yang Hongyang<yanghy@cn.fujitsu.com>
    Signed-off-by: Andrew Morton <akpm@linux-foundation.org>
    Signed-off-by: Linus Torvalds <torvalds@linux-foundation.org>

commit 6a35528a8346f6e6fd32ed7e51f04d1fa4ca2c01
Author: Yang Hongyang <yanghy@cn.fujitsu.com>
Date:   Mon Apr 6 19:01:13 2009 -0700

    dma-mapping: replace all DMA_64BIT_MASK macro with DMA_BIT_MASK(64)
    
    Replace all DMA_64BIT_MASK macro with DMA_BIT_MASK(64)
    
    Signed-off-by: Yang Hongyang<yanghy@cn.fujitsu.com>
    Signed-off-by: Andrew Morton <akpm@linux-foundation.org>
    Signed-off-by: Linus Torvalds <torvalds@linux-foundation.org>

commit 811158b147a503fbdf9773224004ffd32002d1fe
Merge: 4e76c5c b26e0ed
Author: Linus Torvalds <torvalds@linux-foundation.org>
Date:   Fri Apr 3 15:24:35 2009 -0700

    Merge branch 'for-linus' of git://git.kernel.org/pub/scm/linux/kernel/git/jikos/trivial
    
    * 'for-linus' of git://git.kernel.org/pub/scm/linux/kernel/git/jikos/trivial: (28 commits)
      trivial: Update my email address
      trivial: NULL noise: drivers/mtd/tests/mtd_*test.c
      trivial: NULL noise: drivers/media/dvb/frontends/drx397xD_fw.h
      trivial: Fix misspelling of "Celsius".
      trivial: remove unused variable 'path' in alloc_file()
      trivial: fix a pdlfush -> pdflush typo in comment
      trivial: jbd header comment typo fix for JBD_PARANOID_IOFAIL
      trivial: wusb: Storage class should be before const qualifier
      trivial: drivers/char/bsr.c: Storage class should be before const qualifier
      trivial: h8300: Storage class should be before const qualifier
      trivial: fix where cgroup documentation is not correctly referred to
      trivial: Give the right path in Documentation example
      trivial: MTD: remove EOL from MODULE_DESCRIPTION
      trivial: Fix typo in bio_split()'s documentation
      trivial: PWM: fix of #endif comment
      trivial: fix typos/grammar errors in Kconfig texts
      trivial: Fix misspelling of firmware
      trivial: cgroups: documentation typo and spelling corrections
      trivial: Update contact info for Jochen Hein
      trivial: fix typo "resgister" -> "register"
      ...

commit 877d03105d04b2c13e241130277fa69c8d2564f0
Author: Nick Andrew <nick@nick-andrew.net>
Date:   Mon Jan 26 11:06:57 2009 +0100

    trivial: Fix misspelling of firmware
    
    Fix misspelling of firmware.
    
    Signed-off-by: Nick Andrew <nick@nick-andrew.net>
    Signed-off-by: Jiri Kosina <jkosina@suse.cz>

commit 1383bdb98c01bbd28d72336d1bf614ce79114d29
Author: David S. Miller <davem@davemloft.net>
Date:   Sun Mar 29 01:39:49 2009 -0700

    tg3: Add GRO support.
    
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0d2a5068aaa238eba971784585e44130db6d4759
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:40:42 2009 +0000

    tg3: Update copyright and version
    
    This patch updates the copyright to 2009 and updates the version number
    to 3.98.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a6f6cb1cf8ba54efdbbbf61b5b4345b0246da42f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:27:43 2009 +0000

    tg3: Add version reporting for hardware selfboot
    
    This patch adds version reporting for hardware selfboot.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7fd764455a13f4d9b37c9b908f07d0758f11d3c5
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:27:20 2009 +0000

    tg3: Add DASH firmware version reporting
    
    This patch adds code to report the DASH firmware version.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ff3a7cb25217bddcefd20e72af08a65481db4096
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:26:58 2009 +0000

    tg3: Add legacy bootcode version decoding
    
    This patch adds code to obtain the bootcode version for versions
    of bootcode that do not use the new method.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit acd9c119cc663860fff4f1445ed0f87d82378d99
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:26:33 2009 +0000

    tg3: Refactor firmware version routines
    
    This patch reorganizes the firmware version routines in preparation for
    the following patches.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6d348f2c1e0bb1cf7a494b51fc921095ead3f6ae
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:25:52 2009 +0000

    tg3: Eliminate tg3_nvram_read_swab()
    
    The remaining uses of tg3_nvram_read_swab() either intended to read the
    data from NVRAM exactly as tg3_nvram_read_be32() did or hide deeper
    interpretations of the data.  For the former case, a direct replacement
    of tg3_nvram_read_swab() with tg3_nvram_read_be32() is in order.  For
    the latter case, we remove tg3_nvram_read_swab() and document what the
    code is really doing.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a9dc529dcd5c541c51cb2ba09bff99580361c576
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:25:30 2009 +0000

    tg3: Correct NVRAM stream endian notations
    
    Any software requesting NVRAM data as it exists on NVRAM is necessarily
    requesting that the results be returned as a bytestream.  A bytestream
    data read in from the device can also be thought to be in big endian
    format.  Therefore, all the LE notations in the driver are mislabeled.
    This patch converts all LE notations to BE notations, carefully
    evaluating the surrounding code in the process.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e4f341103e4a2b35f56a0f89802f1b1448e8d04b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:25:00 2009 +0000

    tg3: Invert nvram_read() and nvram_read_swab()
    
    This patch removes the blind byteswap of NVRAM data as it is read in.
    To preserve the logic at the call sites, this patch also inverts every
    call to tg3_nvram_read() and tg3_nvram_read_swab().  The call swap gets
    confusing within tg3_nvram_read_le() (LE is a misnomer), but the reader
    should be able to convince himself / herself that the resulting behavior
    is still unchanged.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ffbcfed441b9ba74ce77f215eed6925f6a0b82a3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:24:28 2009 +0000

    tg3: Eliminate nvram routine forward declarations
    
    This patch moves all NVRAM routines earlier in the source file to
    eliminate forward declarations.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 844b3eed8a9efffa4225c811b989c8ff41691a78
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:23:56 2009 +0000

    tg3: Refine tg3_vlan_rx_register()
    
    tg3_vlan_rx_register() touches the hardware if netif_running() returns
    false.  This patch fixes the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7e5856bd9644e2299adbf5d0a8916f9cc56f1f36
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:23:01 2009 +0000

    tg3: Update ethtool set_settings error checks
    
    The ethtool interface has acquired some new enumerations since the
    tg3 driver's tg3_set_settings() error checking code was written.  The
    error checking code is no longer complete.  This patch rewrites the
    error checking so that it is future-proofed.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit f7b493e02101bb5a0a69a91a8b4b7b002cd60eaf
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:21:52 2009 +0000

    tg3: Drop non-VLAN rx pkts larger than the MTU
    
    The hardware's MTU is configured so that it will accept packets whose
    VLAN tag is left inline.  This means that the hardware will also accept
    other packets larger than the desired MTU size.  This patch checks for
    and discards packets that are larger than the requested MTU but are not
    VLAN tagged frames.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit a6435f3a53746a0eb687a9f636cf1941f35f935e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Wed Feb 25 14:21:20 2009 +0000

    tg3: Fix 5906 link problems
    
    Commit 6833c043f9fc03696fde623914c4a0277df2a0bc introduced the phy
    auto-powerdown capability.  While the APD feature only works for 5761
    and 5784 asic revisions, the (harmless portion of the) code was applied
    to all 5705 and newer devices.  However, the 5906 phy departs from the
    usual design.  This commit was interfering with the 5906's ability to
    negotiate link against some switches.  This patch corrects the problem.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e70049b9e74267dd47e1ffa62302073487afcb48
Merge: d18921a f7e603a
Author: David S. Miller <davem@davemloft.net>
Date:   Tue Feb 24 03:50:29 2009 -0800

    Merge branch 'master' of /home/davem/src/GIT/linux-2.6/

commit f72b534961ac38dde17824d7693292eeaadf10e8
Author: Roel Kluin <roel.kluin@gmail.com>
Date:   Wed Feb 18 17:42:42 2009 -0800

    TG3: &&/|| confusion
    
    phyid Can't be both TG3_PHY_OUI_1 and TG3_PHY_OUI_2 and TG3_PHY_OUI_3.
    
    Signed-off-by: Roel Kluin <roel.kluin@gmail.com>
    Acked-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5e30589521518bff36fd2638b3c3d69679c50436
Merge: ac178ef d2f8d7e
Author: David S. Miller <davem@davemloft.net>
Date:   Sat Feb 14 23:12:00 2009 -0800

    Merge branch 'master' of /home/davem/src/GIT/linux-2.6/
    
    Conflicts:
    	drivers/net/wireless/iwlwifi/iwl-agn.c
    	drivers/net/wireless/iwlwifi/iwl3945-base.c

commit d4675b52a933831d4901217564cba5a434ddd922
Author: Roel Kluin <roel.kluin@gmail.com>
Date:   Thu Feb 12 16:33:27 2009 -0800

    TG3: limit reaches -1
    
    With while (limit--) { ... } limit reaches -1, so 0 means success.
    
    Signed-off-by: Roel Kluin <roel.kluin@gmail.com>
    Acked-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3d16543d3235fefca351c10b30c1cca6536f2569
Author: Francois Romieu <romieu@fr.zoreil.com>
Date:   Mon Jan 19 16:56:50 2009 -0800

    tg3: remove extra casting
    
    Signed-off-by: Francois Romieu <romieu@fr.zoreil.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 288379f050284087578b77e04f040b57db3db3f8
Author: Ben Hutchings <bhutchings@solarflare.com>
Date:   Mon Jan 19 16:43:59 2009 -0800

    net: Remove redundant NAPI functions
    
    Following the removal of the unused struct net_device * parameter from
    the NAPI functions named *netif_rx_* in commit 908a7a1, they are
    exactly equivalent to the corresponding *napi_* functions and are
    therefore redundant.
    
    Signed-off-by: Ben Hutchings <bhutchings@solarflare.com>
    Acked-by: Neil Horman <nhorman@tuxdriver.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9e9fd12dc0679643c191fc9795a3021807e77de4
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jan 19 16:57:45 2009 -0800

    tg3: Fix firmware loading
    
    This patch modifies how the tg3 driver handles device firmware.
    
    The patch starts by consolidating David Woodhouse's earlier patch under
    the same name.  Specifically, the patch moves the request_firmware call
    into a separate tg3_request_firmware() function and calls that function
    from tg3_open() rather than tg3_init_one().
    
    The patch then goes on to limit the number of devices that will make
    request_firmware calls.  The original firmware patch unnecessarily
    requested TSO firmware for devices that did not need it.  This patch
    reduces the set of devices making TSO firmware patches to approximately
    the following device set : 5703, 5704, and 5705.
    
    Finally, the patch reduces the effects of a request_firmware() failure.
    For those devices that are requesting TSO firmware, the driver will turn
    off the TSO capability.  If TSO firmware becomes available at a later
    time, the device can be closed and then opened again to reacquire the
    TSO capability.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 077f849de42e58172e25ccb24df4c1a13e82420c
Author: Jaswinder Singh Rajput <jaswinderrajput@gmail.com>
Date:   Sun Jan 4 16:11:25 2009 -0800

    firmware: convert tg3 driver to request_firmware()
    
    Firmware blob looks like this...
            u8 firmware_major
            u8 firmware_minor
            u8 firmware_fix
            u8 pad
            __be32 start_address
            __be32 length (total, including BSS sections to be zeroed)
            data... (in __be32 words, which is native for the firmware)
    
    Signed-off-by: Jaswinder Singh Rajput <jaswinderrajput@gmail.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 908a7a16b852ffd618a9127be8d62432182d81b4
Author: Neil Horman <nhorman@tuxdriver.com>
Date:   Mon Dec 22 20:43:12 2008 -0800

    net: Remove unused netdev arg from some NAPI interfaces.
    
    When the napi api was changed to separate its 1:1 binding to the net_device
    struct, the netif_rx_[prep|schedule|complete] api failed to remove the now
    vestigual net_device structure parameter.  This patch cleans up that api by
    properly removing it..
    
    Signed-off-by: Neil Horman <nhorman@tuxdriver.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d3d317092b58a6df1d31a4ca90cdb9d2bd4ebffa
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Dec 21 20:21:52 2008 -0800

    tg3: Update version to 3.97
    
    This patch updates the version number to 3.97.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit aa10f27d99410cff9145bf91b6efc884c7a4871c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Dec 21 20:21:18 2008 -0800

    tg3: tg3.h cleanups
    
    This patch cleans up the tg3 header file by removing the preprocessor
    definitions for standard PCI configuration space registers.  The driver
    should be using the standard definitions when needed.  The patch
    continues by removing redundant PHY related definitions and reorganizes
    some of the remaining entries.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 69fc405318967c7913e5b55cf3906250a26b49d0
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Dec 21 20:19:57 2008 -0800

    tg3: Remove unused cfgspc device members
    
    This patch removes the pci_bist and pci_hdr_type members from the
    device structure and removes the code that references them.  They are
    not really used.
    
    The patch rounds out the changes by moving the pci_cmd member to plug
    a structure hole that would have been created.  On 32-bit systems, this
    movement removes a subsequent structure hole later in the structure. On
    64-bit systems though, the movement merely consolidates two holes into
    one larger hole.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 027455adacdc142cc018e555ce391014fa227e70
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Dec 21 20:19:30 2008 -0800

    tg3: Cleanup IPV6 LSO
    
    This patch attempts to make the relationship between IPV6 checksum
    offload and IPV6 LSO more obvious.  The patch also toggles a bit
    needed for IPV6 LSO on 5785 and 57780 devices.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2023276ebf074a01eb56f38ed4d04deef1deee67
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Sun Dec 21 20:18:56 2008 -0800

    tg3: WOL fixes
    
    The first hunk of this patch inverts a flag that was accidentally
    toggled as part of commit 0a459aac9d151c2e36ec65723b9b845b24c5cbc3
    ("tg3: Allow WOL for phylib controlled Broadcom phys").
    
    The second hunk of the patch removes the call to
    device_may_wakeup() in the 5906 config detection path.  At the
    point of the call, the driver shouldn't be querying for WOL
    capability.  It should be detecting and setting it.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Benjamin Li <benli@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bc02ff95fe4ebd3e5ee7455c0aa6f76ebe39ebca
Author: Steve Glendinning <steve.glendinning@smsc.com>
Date:   Tue Dec 16 02:00:48 2008 -0800

    net: Refactor full duplex flow control resolution
    
    These 4 drivers have identical full duplex flow control resolution
    functions.  This patch changes them all to use one common function.
    
    The function in question decides whether a device should enable TX and
    RX flow control in a standard way (IEEE 802.3-2005 table 28B-3), so this
    should also be useful for other drivers.
    
    Signed-off-by: Steve Glendinning <steve.glendinning@smsc.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e18ce3465477502108187c6c08b6423fb784a313
Author: Steve Glendinning <steve.glendinning@smsc.com>
Date:   Tue Dec 16 02:00:00 2008 -0800

    net: Move flow control definitions to mii.h
    
    flags used within drivers for indicating tx and rx flow control are
    defined in 4 drivers (and probably more), move these constants to mii.h.
    
    The 3 SMSC drivers use the same constants (FLOW_CTRL_TX), but TG3 uses
    TG3_FLOW_CTRL_TX, so this patch also renames the constants within TG3.
    
    Signed-off-by: Steve Glendinning <steve.glendinning@smsc.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e245a3855eec42127b722ed9688a49ec3f3c9a27
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:23:26 2008 -0800

    tg3: Update version to 3.96
    
    This patch updates the version number to 3.96.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 321d32a052d6b5f71111ebad4fbebea5577f8974
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:22:19 2008 -0800

    tg3: Add 57780 support
    
    This patch adds support for the 57780 ASIC revision.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 22435849a6dcde2ce10d1870aba461a54e347fe3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:21:13 2008 -0800

    tg3: Allow GPHY powerdown on 5761
    
    The ENABLE_APE flag tells the driver whether or not the device has an
    Application Processing Engine (APE).  The APE does not need the PHY to
    be powered unless it is running management firmware.  For backwards
    compatibility, management firmware will still set the ENABLE_ASF bit.
    Consequently, there is no reason to consider the ENABLE_APE flag when
    deciding whether or not to power down the phy.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit d5fe488a7b59e41b98b91137805159466b7b49c2
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:20:32 2008 -0800

    tg3: Embrace pci_ioremap_bar()
    
    Per Dave Miller's suggestion, replace the remaining ioremap_nocache()
    call with pci_ioremap_bar().  Remove the two IORESOURCE_MEM checks as
    they are redundant.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit dfe00d7d890134f9cafda49e3e60e6ce27af91ed
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:19:41 2008 -0800

    tg3: Extract FW ver from alt NVRAM formats
    
    This patch extracts the bootcode firmware version from the alternate
    selfboot patch NVRAM format.  This format is used on the 5784, 5761 and
    some newer devices.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 6833c043f9fc03696fde623914c4a0277df2a0bc
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:18:59 2008 -0800

    tg3: Enable GPHY APD on select devices
    
    GPHY Autopowerdown (APD) is a way to save power when energy is not
    detected on the wire.  At the moment, only the 5784 and 5761 are
    capable of enabling this mode.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5e7dfd0fb94abed04f59481d1ce0cc06a892048a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:18:16 2008 -0800

    tg3: Prevent corruption at 10 / 100Mbps w CLKREQ
    
    This patch disables CLKREQ at 10Mbps and 100Mbps to workaround a TX BD
    corruption issue.  This problem only affects the 5784 and 5761 (and
    57780 AX) ASIC revisions.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 52f4490c3b6dcb1e8dec7ff9f1c35f09bd7c136f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:17:04 2008 -0800

    tg3: Qualify use of tp->pcix_cap
    
    This patch makes sure the device is a PCIX device before attempting to
    use the pcix_cap device structure member.  This is prep work for the
    following patch.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit ad8292681a629cdb16bb19ee7d721b457c32a23a
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Nov 21 17:16:16 2008 -0800

    tg3: Use NET_IP_ALIGN
    
    This patch replaces hardcoded 2's with the NET_IP_ALIGN constant or
    TG3_RAW_IP_ALIGN where appropriate.  Some platforms can redefine the
    NET_IP_ALIGN definition to zero if unaligned DMA transfers cost more
    than the IP header alignment gains.  This patch represents a
    performance improvement when using the 5701 on these platforms.
    The copy path can be avoided.
    
    TG3_RAW_IP_ALIGN is used in cases where we always want to align the
    IP header on dword boundaries.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 008298231abbeb91bc7be9e8b078607b816d1a4a
Author: Stephen Hemminger <shemminger@vyatta.com>
Date:   Thu Nov 20 20:14:53 2008 -0800

    netdev: add more functions to netdevice ops
    
    This patch moves neigh_setup and hard_start_xmit into the network device ops
    structure. For bisection, fix all the previously converted drivers as well.
    Bonding driver took the biggest hit on this.
    
    Added a prefetch of the hard_start_xmit in the fast path to try and reduce
    any impact this would have.
    
    Signed-off-by: Stephen Hemminger <shemminger@vyatta.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 7c7d64b8c00bcf9519e5ec38368bc7afdc185c51
Author: Stephen Hemminger <shemminger@vyatta.com>
Date:   Wed Nov 19 22:25:36 2008 -0800

    tg3: convert to net_device_ops
    
    Convert this driver to network device ops.
    
    Signed-off-by: Stephen Hemminger <shemminger@vyatta.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fb28ad35906af2f042c94e2f9c0f898ef9acfa37
Author: Kay Sievers <kay.sievers@vrfy.org>
Date:   Mon Nov 10 13:55:14 2008 -0800

    net: struct device - replace bus_id with dev_name(), dev_set_name()
    
    Acked-by: Marcel Holtmann <marcel@holtmann.org>
    Acked-by: Greg Kroah-Hartman <gregkh@suse.de>
    Signed-off-by: Kay Sievers <kay.sievers@vrfy.org>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit babcda74e9d96bb58fd9c6c5112dbdbff169e695
Author: David S. Miller <davem@davemloft.net>
Date:   Mon Nov 3 21:11:17 2008 -0800

    drivers/net: Kill now superfluous ->last_rx stores.
    
    The generic packet receive code takes care of setting
    netdev->last_rx when necessary, for the sake of the
    bonding ARP monitor.
    
    Drivers need not do it any more.
    
    Some cases had to be skipped over because the drivers
    were making use of the ->last_rx value themselves.
    
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fa228b3fcb724ce2281a61737e09a8afa4fed542
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:58:53 2008 -0800

    tg3: Update version to 3.95
    
    This patch updates the version to 3.95.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit fcb389dfd842be54545cb436b3437f07da10115c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:55:44 2008 -0800

    tg3: 5785 enhancements
    
    This patch refines support for the 5785 device.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 9c61d6bc56bf0a5fb1ebfcf4c168cc5ce30e153b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:54:56 2008 -0800

    tg3: Refine phylib support
    
    This patch refines the phylib support in the tg3 driver.  The patch does
    the following things :
    
    * Rename tg3_mdio_config() to tg3_mdio_config_5785().  The 5785 will be
      the only device that will use it so the name might as well reflect
      that.
    * Fix a memory leak if mdiobus_register() fails.
    * Add code to deal with phy device detection failures.
    * Add code to correct the supported list of phy features based on the
      MAC <=> PHY interface.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0a459aac9d151c2e36ec65723b9b845b24c5cbc3
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:54:15 2008 -0800

    tg3: Allow WOL for phylib controlled Broadcom phys
    
    This patch allows WOL to be enabled for Broadcom phys under phylib
    control.  The only exception is the AC131, which has a completely
    different register set.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 05ac4cb7dff4515447dce6e9a56c4de6b7e426d5
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:53:46 2008 -0800

    tg3: Refine power management and WOL code
    
    Commit 12dac0756d357325b107fe6ec24921ec38661839 ("tg3: adapt tg3 to
    use reworked PCI PM code") introduced the new PCI PM API to the tg3
    driver.  The patch was understandably conservative, so this patch
    elaborates on that work.
    
    The patch starts by creating a single point in tg3_set_power_state()
    to decide whether or not to enable WOL.  The rest of the code in
    tg3_set_power_state() was then pivoted to use the result of this
    decision.
    
    The patch then makes sure the device is allowed to wakeup before
    reporting whether or not WOL is currently enabled.  The final hunks of
    the patch consolidate where the WOL capability and WOL enabled flags
    are set to a single location.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit df59c9403557397aafbe291533d113b752da7661
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:52:56 2008 -0800

    tg3: Move phylib report to end of tg3_init_one
    
    Currently, phylib reports appear with a eth%d prefix.  Move the line
    after register_netdev() and place it alongside the other informative
    messages.  Update nearby informative messages accordingly.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b2b98d4acc58a6f36b731e666c6ebd901cd6a27e
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:52:32 2008 -0800

    tg3: Do not enable APE on bcm5700
    
    With older versions of the NVRAM format, the driver may mistakenly
    determine that APE is enabled.  Make sure this doesn't happen by
    restricting the ENABLE_APE check to devices known to have more
    recent NVRAM image formats.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bcb37f6cb57e565e7bd342272652c3a50cf88761
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:52:09 2008 -0800

    tg3: Reclaim TG3_FLG3_5761_5784_AX_FIXES flag
    
    This patch reclaims the TG3_FLG3_5761_5784_AX_FIXES flag.  It only
    used twice in non-fast paths.  This patch also consolidates some other
    places where specific 5784 AX chip revisions can be generalized.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3f007891da0ad3d9192e9aa13ce4e3aaf20c33fa
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:51:36 2008 -0800

    tg3: Preserve LAA when device control is released
    
    This patch moves the __tg3_set_mac_addr() function earlier in the file
    listing, to avoid a function prototype, and calls the function to
    restore the LAA after a driver unload chip reset.  With this code in
    place, the administrator can wake the machine using the LAA.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit b2aee1545dc3c05c8d5cf116de1e92907e98009b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:51:11 2008 -0800

    tg3: Preserve DASH connectivity when WOL enabled
    
    DASH firmware runs on the APE side of the chip, but it requires a few MAC
    to be programmed correctly.
    
    When WOL is enabled and management firmware is disabled, incoming
    packets are evaluated and discarded at the chip's rule processor.
    When management firmware is enabled, the hardware must be informed that
    there are agents further up the stack that still use the incoming
    frames.  Normally management firmware will configure the MAC correctly
    on its own, but there can be cases where the setting could get clobbered
    by the driver.  The first hunk of this patch preserves this setting.
    
    The second hunk of this patch wipes out the driver present signature of
    the APE memory space.  By doing so, the DASH firmware can assume
    driver absent behavior.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 63532394af307795ea637a283bd1fd057f5dfcea
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:49:57 2008 -0800

    tg3: Use pci_ioremap_bar()
    
    This patch replaces the existing APE register mapping code with a call
    to pci_ioremap_bar().  The code that maps the main device register space
    did not undergo a similar change because the information derived from
    the pci_resource_start() and pci_resource_len() is still used to
    populate the (optional) mem_start and mem_end netdevice members.
    Replace hardcoded constants where appropriate.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit c88e668b52c8cd8bc55b6734c7dfbb0cb005d445
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Nov 3 16:49:18 2008 -0800

    tg3: Add 5761S support
    
    This patch adds support for the 5761S chip variants.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit e174961ca1a0b28f7abf0be47973ad57cb74e5f0
Author: Johannes Berg <johannes@sipsolutions.net>
Date:   Mon Oct 27 15:59:26 2008 -0700

    net: convert print_mac to %pM
    
    This converts pretty much everything to print_mac. There were
    a few things that had conflicts which I have just dropped for
    now, no harm done.
    
    I've built an allyesconfig with this and looked at the files
    that weren't built very carefully, but it's a huge patch.
    
    Signed-off-by: Johannes Berg <johannes@sipsolutions.net>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 298cf9beb9679522de995e249eccbd82f7c51999
Author: Lennert Buytenhek <buytenh@marvell.com>
Date:   Wed Oct 8 16:29:57 2008 -0700

    phylib: move to dynamic allocation of struct mii_bus
    
    This patch introduces mdiobus_alloc() and mdiobus_free(), and
    makes all mdio bus drivers use these functions to allocate their
    struct mii_bus'es dynamically.
    
    Signed-off-by: Lennert Buytenhek <buytenh@marvell.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>
    Acked-by: Andy Fleming <afleming@freescale.com>

commit 18ee49ddb0d242ed1d0e273038d5e4f6de7379d3
Author: Lennert Buytenhek <buytenh@wantstofly.org>
Date:   Wed Oct 1 15:41:33 2008 +0000

    phylib: rename mii_bus::dev to mii_bus::parent
    
    In preparation of giving mii_bus objects a device tree presence of
    their own, rename struct mii_bus's ->dev argument to ->parent, since
    having a 'struct device *dev' that points to our parent device
    conflicts with introducing a 'struct device dev' representing our own
    device.
    
    Signed-off-by: Lennert Buytenhek <buytenh@marvell.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>
    Acked-by: Andy Fleming <afleming@freescale.com>

commit 638266f7e879e34de4a4635049c15f5a58505e75
Author: David S. Miller <davem@davemloft.net>
Date:   Thu Sep 11 15:45:19 2008 -0700

    tg3: Fix DMA mapping leak in tigon3_dma_hwbug_workaround().
    
    Noticed by Michael Chan.
    
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 90079ce89aa65e17f36ac2b09110720c51d874f4
Author: David S. Miller <davem@davemloft.net>
Date:   Thu Sep 11 04:52:51 2008 -0700

    tg3: Use SKB DMA helper functions for TX.
    
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 23197916c447a1623d196e6547781180905f0bb2
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 15 14:11:19 2008 -0700

    tg3: Update version to 3.94
    
    This patch updates the version number to 3.94.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 816f8b86621000fc82e16ae5f172164de761d5eb
Author: Stefan Buehler <stbuehler@web.de>
Date:   Fri Aug 15 14:10:54 2008 -0700

    tg3: fix 64 bit counter for ethtool stats
    
    Ethtool stats are 64-bits in length.  net_device_stats members are
    unsigned long types.  When gathering information for
    a get_ethtool_stats call, the driver will call a driver-private,
    inlined get_stat64() function, which returns an unsigned long value.
    This call will inadvertently mask off the upper 32-bits of a stat on
    32-bit machines.
    
    This patch defines a new get_estat() inline function and modifies the
    ESTAT_ADD() macro to use it.
    
    Signed-off-by: Stefan Buehler <stbuehler@web.de>
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 4ba526ced990f4d61ee8d65fe8a6f0745e8e455c
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 15 14:10:04 2008 -0700

    tg3: Fix firmware event timeouts
    
    The git commit 7c5026aa9b81dd45df8d3f4e0be73e485976a8b6 ("tg3: Add
    link state reporting to UMP firmware") introduced code that waits for
    previous firmware events to be serviced before attempting to submit a
    new event.  Unfortunately that patch contained a bug that cause the
    driver to wait 2.5 seconds, rather than 2.5 milliseconds as intended.
    This patch fixes that bug.
    
    This bug revealed that not all firmware versions service driver events
    though.  Since we do not know which versions of the firmware do and don't
    service these events, the driver needs some way to minimize the effects
    of the delay.  This patch solves the problem by recording a jiffies
    timestamp when it submits an event to the hardware.  If the jiffies
    counter shows that 2.5 milliseconds have already passed, a wait is not
    needed and the driver can proceed to submit a new event.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit bc7959b2cbb57393b625b423c73e6fd07610257f
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 15 14:08:55 2008 -0700

    tg3: Turn off ASF "driver alive" heartbeats for APE
    
    The ENABLE_ASF flag is set when DASH is enabled on the NIC, but DASH
    does not run on the RX CPU.  Instead it runs on the APE.
    Consequently, the driver does not need to send "driver alive" updates
    to the RX CPU when the APE is present.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 3bda12589646caa22b2ed4ef7cf82d17ea59d7a6
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 15 14:08:22 2008 -0700

    tg3: Preserve register settings for DASH
    
    Broadcom's DASH (Desktop and mobile Architecture for System Hardware)
    implementation requires that the driver preserve particular register
    settings.  If the driver does not preserve them, communication with
    the DASH firmware will be lost.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 731fd79c133dc04cabee17ecfa7661189a8df5c8
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 15 14:07:51 2008 -0700

    tg3: Refine APE status check
    
    Recently, more status bits have been added to the APE status register.
    This patch refines the status register check so that the driver can
    send more events than it would have otherwise.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 77b483f132ba25edf4ef455dd87a91ab7bbf4170
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Fri Aug 15 14:07:24 2008 -0700

    tg3: Add APE register access locking
    
    If the driver resets the chip while the APE is performing a register
    access, that register access will never complete and the APE will hang
    indefinitely.  To prevent this race condition, the driver must acquire
    an APE mutex before resetting the chip.  The APE will not attempt a
    register access until it acquires this lock.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2f751b67a8be698cec52f786910ef4f0beffe9a7
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Aug 4 23:17:34 2008 -0700

    tg3: Fix 'scheduling while atomic' errors
    
    This patch fixes the 'scheduling while atomic' errors introduced by
    commit 12dac0756d357325b107fe6ec24921ec38661839 ("tg3: adapt tg3 to
    use reworked PCI PM code").
    
    The first hunk of the patch removes an unnecessary
    tg3_set_power_state() call.  The chip will already be in the D0 state
    either due to a chip reset or through a previous call to
    tg3_set_power_state().
    
    The second hunk of the patch moves the tg3_set_power_state() call
    outside the critical section guarded by tg3_full_lock() and
    tg3_full_unlock() functions.  The power state of the device is and
    should be outside the lock's domain and all other
    tg3_set_power_state() calls support this.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 12dac0756d357325b107fe6ec24921ec38661839
Author: Rafael J. Wysocki <rjw@sisk.pl>
Date:   Wed Jul 30 16:37:33 2008 -0700

    tg3: adapt tg3 to use reworked PCI PM code
    
    Adapt the tg3 driver to use the reworked PCI PM and make it use the
    exported PCI PM core functions instead of accessing the PCI PM registers
    directly by itself.
    
    Signed-off-by: Rafael J. Wysocki <rjw@sisk.pl>
    Signed-off-by: Andrew Morton <akpm@linux-foundation.org>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 65b53e4cc90e59936733b3b95b9451d2ca47528d
Merge: 788c0a5 2e761e0
Author: David S. Miller <davem@davemloft.net>
Date:   Tue Jun 10 02:22:26 2008 -0700

    Merge branch 'master' of master.kernel.org:/pub/scm/linux/kernel/git/davem/net-2.6
    
    Conflicts:
    
    	drivers/net/tg3.c
    	drivers/net/wireless/rt2x00/rt2x00dev.c
    	net/mac80211/ieee80211_i.h

commit 1b84d9462a93ccfa99f725aad744ab4d1af8402b
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 9 15:41:33 2008 -0700

    tg3: Update version to 3.92.1
    
    This patch increments the version to 3.92.1.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 5f0c4a3cb6fda7c505f8c916b54ea90205feed68
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 9 15:41:12 2008 -0700

    tg3: Fix 5761 WOL
    
    On 5761 non-e devices, two problems prevent the administrator from
    overriding the WOL settings in the device's NVRAM.
    
    The first problem is that GPIO 0 and GPIO 2 have been swapped.  This
    change prevented the administrator from turning on WOL when it is
    disabled in NVRAM.  The fix is to add a new path for the 5761 that
    swaps the two GPIOs in the code as well.
    
    The second problem is that GPIO 1 could not be toggled by the driver
    because the GPIO is shared with the debug UART GPIO.  This will prevent
    the administrator from being able to turn WOL off if it was enabled in
    NVRAM.  The fix is to always disable the debug UART after a GRC reset.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 0ba11fb307a4f18c11df6f5f255158ce055a2a16
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 9 15:40:26 2008 -0700

    tg3: Fix a flags typo
    
    This patch fixes a problem where the TG3_FLAG_10_100_ONLY flag was
    testing against the wrong flags variable.
    
    Signed-off-by: Matt Carlson <mcarlson@broadcom.com>
    Signed-off-by: Michael Chan <mchan@broadcom.com>
    Signed-off-by: David S. Miller <davem@davemloft.net>

commit 2bd3ed0479c35f7c8dadecf72b725ca0c20ea015
Author: Matt Carlson <mcarlson@broadcom.com>
Date:   Mon Jun 9 15:39:55 2008 -0700

    tg3: Fix 5714S / 5715S / 5780S link failures
    
    The git commit ef167e27039eeaea6d3cdd5c547b082e89840bdd entitled
    "Fix supporting flowctrl code" introduced a bug that prevents 5714S,
    5715S and 5780S devices from falling back to a forced link mode.  The
    problem is that the added flow control check will always fail if flow
